/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arith_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t1 = nm->mkBoundVar("t1", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(t1);
Node s2 = nm->mkBoundVar("s2", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(s2);
Node t3 = nm->mkBoundVar("t3", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(t3);
Node s4 = nm->mkBoundVar("s4", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(s4);
Node t5 = nm->mkBoundVar("t5", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(t5);
Node s6 = nm->mkBoundVar("s6", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(s6);
Node t7 = nm->mkBoundVar("t7", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s8 = nm->mkBoundVar("s8", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t9 = nm->mkBoundVar("t9", nm->integerType());
Node s10 = nm->mkBoundVar("s10", nm->integerType());
Node t11 = nm->mkBoundVar("t11", nm->integerType());
Node t12 = nm->mkBoundVar("t12", nm->integerType());
Node t13 = nm->mkBoundVar("t13", nm->integerType());
Node s14 = nm->mkBoundVar("s14", nm->integerType());
Node t15 = nm->mkBoundVar("t15", nm->integerType());
Node t16 = nm->mkBoundVar("t16", nm->integerType());
Node t17 = nm->mkBoundVar("t17", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t18 = nm->mkBoundVar("t18", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t19 = nm->mkBoundVar("t19", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s20 = nm->mkBoundVar("s20", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t21 = nm->mkBoundVar("t21", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s22 = nm->mkBoundVar("s22", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t23 = nm->mkBoundVar("t23", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s24 = nm->mkBoundVar("s24", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t25 = nm->mkBoundVar("t25", nm->integerType());
Node s26 = nm->mkBoundVar("s26", nm->integerType());
Node t27 = nm->mkBoundVar("t27", nm->integerType());
Node s28 = nm->mkBoundVar("s28", nm->integerType());
Node t29 = nm->mkBoundVar("t29", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s30 = nm->mkBoundVar("s30", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t31 = nm->mkBoundVar("t31", nm->integerType());
Node s32 = nm->mkBoundVar("s32", nm->integerType());
Node t33 = nm->mkBoundVar("t33", nm->integerType());
Node s34 = nm->mkBoundVar("s34", nm->integerType());
Node t35 = nm->mkBoundVar("t35", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s36 = nm->mkBoundVar("s36", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t37 = nm->mkBoundVar("t37", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s38 = nm->mkBoundVar("s38", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t39 = nm->mkBoundVar("t39", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t40 = nm->mkBoundVar("t40", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t41 = nm->mkBoundVar("t41", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t42 = nm->mkBoundVar("t42", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t43 = nm->mkBoundVar("t43", nm->realType());
Node s44 = nm->mkBoundVar("s44", nm->realType());
Node t45 = nm->mkBoundVar("t45", nm->integerType());
Node s46 = nm->mkBoundVar("s46", nm->integerType());
Node xs47 = nm->mkBoundVar("xs47", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(xs47);
Node w48 = nm->mkBoundVar("w48", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node ys49 = nm->mkBoundVar("ys49", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(ys49);
Node zs50 = nm->mkBoundVar("zs50", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(zs50);
Node t74 = nm->mkBoundVar("t74", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs51 = nm->mkBoundVar("xs51", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(xs51);
Node w52 = nm->mkBoundVar("w52", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node ys53 = nm->mkBoundVar("ys53", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(ys53);
Node zs54 = nm->mkBoundVar("zs54", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(zs54);
Node t75 = nm->mkBoundVar("t75", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x55 = nm->mkBoundVar("x55", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y56 = nm->mkBoundVar("y56", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z57 = nm->mkBoundVar("z57", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node w58 = nm->mkBoundVar("w58", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(w58);
Node t76 = nm->mkBoundVar("t76", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t59 = nm->mkBoundVar("t59", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(t59);
Node x60 = nm->mkBoundVar("x60", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s61 = nm->mkBoundVar("s61", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(s61);
Node r62 = nm->mkBoundVar("r62", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(r62);
Node t77 = nm->mkBoundVar("t77", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t63 = nm->mkBoundVar("t63", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(t63);
Node x64 = nm->mkBoundVar("x64", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s65 = nm->mkBoundVar("s65", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(s65);
Node r66 = nm->mkBoundVar("r66", nm->mkAbstractType(Kind::ABSTRACT_TYPE));expr::markListVar(r66);
Node t78 = nm->mkBoundVar("t78", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x67 = nm->mkBoundVar("x67", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x68 = nm->mkBoundVar("x68", nm->realType());
Node x69 = nm->mkBoundVar("x69", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x70 = nm->mkBoundVar("x70", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y71 = nm->mkBoundVar("y71", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x72 = nm->mkBoundVar("x72", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y73 = nm->mkBoundVar("y73", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e79 = nm->mkConst(true);
Node e80 = nm->mkConstRealOrInt(-(Rational(1)));
Node e81 = nm->mkConst(false);
Node e82 = nm->mkConstRealOrInt(Rational(0));
Node e83 = nm->mkConstRealOrInt(Rational(1));

  // Rules

        {
            // from rewrites-arith-rewrites.cpp
            db.addRule(ProofRewriteRule::ARITH_PLUS_ZERO, { t1, s2 }, nm->mkNode(Kind::ADD, { t1,e82,s2 }), nm->mkNode(Kind::ADD, { t1,s2 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_MUL_ONE, { t3, s4 }, nm->mkNode(Kind::MULT, { t3,e83,s4 }), nm->mkNode(Kind::MULT, { t3,s4 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_MUL_ZERO, { t5, s6 }, nm->mkNode(Kind::MULT, { t5,e82,s6 }), e82, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_TOTAL, { t7, s8 }, nm->mkNode(Kind::DIVISION, { t7,s8 }), nm->mkNode(Kind::DIVISION_TOTAL, { t7,s8 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s8,e82 }) }), Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL, { t9, s10 }, nm->mkNode(Kind::INTS_DIVISION, { t9,s10 }), nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t9,s10 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s10,e82 }) }), Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL_ONE, { t11 }, nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t11,e83 }), t11, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL_ZERO, { t12 }, nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t12,e82 }), e82, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL, { t13, s14 }, nm->mkNode(Kind::INTS_MODULUS, { t13,s14 }), nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t13,s14 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s14,e82 }) }), Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL_ONE, { t15 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t15,e83 }), e82, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL_ZERO, { t16 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t16,e82 }), t16, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_NEG_NEG_ONE, { t17 }, nm->mkNode(Kind::MULT, { e80,nm->mkNode(Kind::MULT, { e80,t17 }) }), t17, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_UMINUS, { t18 }, nm->mkNode(Kind::NEG, { t18 }), nm->mkNode(Kind::MULT, { e80,t18 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_MINUS, { t19, s20 }, nm->mkNode(Kind::SUB, { t19,s20 }), nm->mkNode(Kind::ADD, { t19,nm->mkNode(Kind::MULT, { e80,s20 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_GT, { t21, s22 }, nm->mkNode(Kind::GT, { t21,s22 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::LEQ, { t21,s22 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_LT, { t23, s24 }, nm->mkNode(Kind::LT, { t23,s24 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t23,s24 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_INT_GT, { t25, s26 }, nm->mkNode(Kind::GT, { t25,s26 }), nm->mkNode(Kind::GEQ, { t25,nm->mkNode(Kind::ADD, { s26,e83 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_INT_LT, { t27, s28 }, nm->mkNode(Kind::LT, { t27,s28 }), nm->mkNode(Kind::GEQ, { s28,nm->mkNode(Kind::ADD, { t27,e83 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_ELIM_LEQ, { t29, s30 }, nm->mkNode(Kind::LEQ, { t29,s30 }), nm->mkNode(Kind::GEQ, { s30,t29 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_LEQ_NORM, { t31, s32 }, nm->mkNode(Kind::LEQ, { t31,s32 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t31,nm->mkNode(Kind::ADD, { s32,e83 }) }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_GEQ_TIGHTEN, { t33, s34 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t33,s34 }) }), nm->mkNode(Kind::GEQ, { s34,nm->mkNode(Kind::ADD, { t33,e83 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_GEQ_NORM1, { t35, s36 }, nm->mkNode(Kind::GEQ, { t35,s36 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { t35,s36 }),e82 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_GEQ_NORM2, { t37, s38 }, nm->mkNode(Kind::GEQ, { t37,s38 }), nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::NEG, { t37 }),nm->mkNode(Kind::NEG, { s38 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_LEQ, { t39 }, nm->mkNode(Kind::LEQ, { t39,t39 }), e79, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_LT, { t40 }, nm->mkNode(Kind::LT, { t40,t40 }), e81, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_GEQ, { t41 }, nm->mkNode(Kind::GEQ, { t41,t41 }), e79, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_REFL_GT, { t42 }, nm->mkNode(Kind::GT, { t42,t42 }), e81, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_REAL_EQ_ELIM, { t43, s44 }, nm->mkNode(Kind::EQUAL, { t43,s44 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { t43,s44 }),nm->mkNode(Kind::LEQ, { t43,s44 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_INT_EQ_ELIM, { t45, s46 }, nm->mkNode(Kind::EQUAL, { t45,s46 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { t45,s46 }),nm->mkNode(Kind::LEQ, { t45,s46 }) }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_PLUS_FLATTEN, { xs47, w48, ys49, zs50 }, nm->mkNode(Kind::ADD, { xs47,nm->mkNode(Kind::ADD, { w48,ys49 }),zs50 }), nm->mkNode(Kind::ADD, { xs47,w48,ys49,zs50 }), e79, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t74 }),t74 }));
db.addRule(ProofRewriteRule::ARITH_MULT_FLATTEN, { xs51, w52, ys53, zs54 }, nm->mkNode(Kind::MULT, { xs51,nm->mkNode(Kind::MULT, { w52,ys53 }),zs54 }), nm->mkNode(Kind::MULT, { xs51,w52,ys53,zs54 }), e79, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t75 }),t75 }));
db.addRule(ProofRewriteRule::ARITH_MULT_DIST, { x55, y56, z57, w58 }, nm->mkNode(Kind::MULT, { x55,nm->mkNode(Kind::ADD, { y56,z57,w58 }) }), nm->mkNode(Kind::ADD, { nm->mkNode(Kind::MULT, { x55,y56 }),nm->mkNode(Kind::MULT, { x55,nm->mkNode(Kind::ADD, { z57,w58 }) }) }), e79, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t76 }),t76 }));
db.addRule(ProofRewriteRule::ARITH_PLUS_CANCEL1, { t59, x60, s61, r62 }, nm->mkNode(Kind::ADD, { t59,x60,s61,nm->mkNode(Kind::MULT, { e80,x60 }),r62 }), nm->mkNode(Kind::ADD, { t59,s61,r62 }), e79, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t77 }),t77 }));
db.addRule(ProofRewriteRule::ARITH_PLUS_CANCEL2, { t63, x64, s65, r66 }, nm->mkNode(Kind::ADD, { t63,nm->mkNode(Kind::MULT, { e80,x64 }),s65,x64,r66 }), nm->mkNode(Kind::ADD, { t63,s65,r66 }), e79, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t78 }),t78 }));
db.addRule(ProofRewriteRule::ARITH_ABS_ELIM, { x67 }, nm->mkNode(Kind::ABS, { x67 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { x67,e82 }),nm->mkNode(Kind::NEG, { x67 }),x67 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_TO_REAL_ELIM, { x68 }, nm->mkNode(Kind::TO_REAL, { x68 }), x68, e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_TO_INT_ELIM_TO_REAL, { x69 }, nm->mkNode(Kind::TO_INTEGER, { nm->mkNode(Kind::TO_REAL, { x69 }) }), nm->mkNode(Kind::TO_INTEGER, { x69 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_ELIM_TO_REAL1, { x70, y71 }, nm->mkNode(Kind::DIVISION, { nm->mkNode(Kind::TO_REAL, { x70 }),y71 }), nm->mkNode(Kind::DIVISION, { x70,y71 }), e79, Node::null());
db.addRule(ProofRewriteRule::ARITH_DIV_ELIM_TO_REAL2, { x72, y73 }, nm->mkNode(Kind::DIVISION, { x72,nm->mkNode(Kind::TO_REAL, { y73 }) }), nm->mkNode(Kind::DIVISION, { x72,y73 }), e79, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
