/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_booleans_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t98 = nm->mkBoundVar("t98", nm->booleanType());
Node t99 = nm->mkBoundVar("t99", nm->booleanType());
Node t100 = nm->mkBoundVar("t100", nm->booleanType());
Node t101 = nm->mkBoundVar("t101", nm->booleanType());
Node t102 = nm->mkBoundVar("t102", nm->booleanType());
Node x103 = nm->mkBoundVar("x103", nm->booleanType());
Node t104 = nm->mkBoundVar("t104", nm->booleanType());
Node t105 = nm->mkBoundVar("t105", nm->booleanType());
Node t106 = nm->mkBoundVar("t106", nm->booleanType());
Node t107 = nm->mkBoundVar("t107", nm->booleanType());
Node t108 = nm->mkBoundVar("t108", nm->booleanType());
Node s109 = nm->mkBoundVar("s109", nm->booleanType());
Node xs110 = nm->mkBoundVar("xs110", nm->booleanType());expr::markListVar(xs110);
Node ys111 = nm->mkBoundVar("ys111", nm->booleanType());expr::markListVar(ys111);
Node xs112 = nm->mkBoundVar("xs112", nm->booleanType());expr::markListVar(xs112);
Node ys113 = nm->mkBoundVar("ys113", nm->booleanType());expr::markListVar(ys113);
Node t180 = nm->mkBoundVar("t180", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs114 = nm->mkBoundVar("xs114", nm->booleanType());expr::markListVar(xs114);
Node b115 = nm->mkBoundVar("b115", nm->booleanType());
Node ys116 = nm->mkBoundVar("ys116", nm->booleanType());expr::markListVar(ys116);
Node zs117 = nm->mkBoundVar("zs117", nm->booleanType());expr::markListVar(zs117);
Node t181 = nm->mkBoundVar("t181", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs118 = nm->mkBoundVar("xs118", nm->booleanType());expr::markListVar(xs118);
Node b119 = nm->mkBoundVar("b119", nm->booleanType());
Node ys120 = nm->mkBoundVar("ys120", nm->booleanType());expr::markListVar(ys120);
Node zs121 = nm->mkBoundVar("zs121", nm->booleanType());expr::markListVar(zs121);
Node t182 = nm->mkBoundVar("t182", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs122 = nm->mkBoundVar("xs122", nm->booleanType());expr::markListVar(xs122);
Node ys123 = nm->mkBoundVar("ys123", nm->booleanType());expr::markListVar(ys123);
Node t183 = nm->mkBoundVar("t183", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs124 = nm->mkBoundVar("xs124", nm->booleanType());expr::markListVar(xs124);
Node ys125 = nm->mkBoundVar("ys125", nm->booleanType());expr::markListVar(ys125);
Node xs126 = nm->mkBoundVar("xs126", nm->booleanType());expr::markListVar(xs126);
Node b127 = nm->mkBoundVar("b127", nm->booleanType());
Node ys128 = nm->mkBoundVar("ys128", nm->booleanType());expr::markListVar(ys128);
Node zs129 = nm->mkBoundVar("zs129", nm->booleanType());expr::markListVar(zs129);
Node t184 = nm->mkBoundVar("t184", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs130 = nm->mkBoundVar("xs130", nm->booleanType());expr::markListVar(xs130);
Node b131 = nm->mkBoundVar("b131", nm->booleanType());
Node ys132 = nm->mkBoundVar("ys132", nm->booleanType());expr::markListVar(ys132);
Node zs133 = nm->mkBoundVar("zs133", nm->booleanType());expr::markListVar(zs133);
Node t185 = nm->mkBoundVar("t185", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs134 = nm->mkBoundVar("xs134", nm->booleanType());expr::markListVar(xs134);
Node w135 = nm->mkBoundVar("w135", nm->booleanType());
Node ys136 = nm->mkBoundVar("ys136", nm->booleanType());expr::markListVar(ys136);
Node zs137 = nm->mkBoundVar("zs137", nm->booleanType());expr::markListVar(zs137);
Node xs138 = nm->mkBoundVar("xs138", nm->booleanType());expr::markListVar(xs138);
Node w139 = nm->mkBoundVar("w139", nm->booleanType());
Node ys140 = nm->mkBoundVar("ys140", nm->booleanType());expr::markListVar(ys140);
Node zs141 = nm->mkBoundVar("zs141", nm->booleanType());expr::markListVar(zs141);
Node x142 = nm->mkBoundVar("x142", nm->booleanType());
Node y143 = nm->mkBoundVar("y143", nm->booleanType());
Node zs144 = nm->mkBoundVar("zs144", nm->booleanType());expr::markListVar(zs144);
Node t186 = nm->mkBoundVar("t186", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x145 = nm->mkBoundVar("x145", nm->booleanType());
Node y146 = nm->mkBoundVar("y146", nm->booleanType());
Node x147 = nm->mkBoundVar("x147", nm->booleanType());
Node y148 = nm->mkBoundVar("y148", nm->booleanType());
Node zs149 = nm->mkBoundVar("zs149", nm->booleanType());expr::markListVar(zs149);
Node t187 = nm->mkBoundVar("t187", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x150 = nm->mkBoundVar("x150", nm->booleanType());
Node x151 = nm->mkBoundVar("x151", nm->booleanType());
Node x152 = nm->mkBoundVar("x152", nm->booleanType());
Node x153 = nm->mkBoundVar("x153", nm->booleanType());
Node x154 = nm->mkBoundVar("x154", nm->booleanType());
Node y155 = nm->mkBoundVar("y155", nm->booleanType());
Node x156 = nm->mkBoundVar("x156", nm->booleanType());
Node y157 = nm->mkBoundVar("y157", nm->booleanType());
Node x158 = nm->mkBoundVar("x158", nm->booleanType());
Node y159 = nm->mkBoundVar("y159", nm->booleanType());
Node x160 = nm->mkBoundVar("x160", nm->booleanType());
Node y161 = nm->mkBoundVar("y161", nm->booleanType());
Node c162 = nm->mkBoundVar("c162", nm->booleanType());
Node x163 = nm->mkBoundVar("x163", nm->booleanType());
Node y164 = nm->mkBoundVar("y164", nm->booleanType());
Node c165 = nm->mkBoundVar("c165", nm->booleanType());
Node x166 = nm->mkBoundVar("x166", nm->booleanType());
Node c167 = nm->mkBoundVar("c167", nm->booleanType());
Node x168 = nm->mkBoundVar("x168", nm->booleanType());
Node c169 = nm->mkBoundVar("c169", nm->booleanType());
Node x170 = nm->mkBoundVar("x170", nm->booleanType());
Node c171 = nm->mkBoundVar("c171", nm->booleanType());
Node x172 = nm->mkBoundVar("x172", nm->booleanType());
Node c173 = nm->mkBoundVar("c173", nm->booleanType());
Node x174 = nm->mkBoundVar("x174", nm->booleanType());
Node c175 = nm->mkBoundVar("c175", nm->booleanType());
Node x176 = nm->mkBoundVar("x176", nm->booleanType());
Node c177 = nm->mkBoundVar("c177", nm->booleanType());
Node x178 = nm->mkBoundVar("x178", nm->booleanType());
Node y179 = nm->mkBoundVar("y179", nm->booleanType());

  // Definitions
Node e188 = nm->mkConst(true);
Node e189 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-booleans-rewrites.cpp
            db.addRule(ProofRewriteRule::BOOL_DOUBLE_NOT_ELIM, { t98 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::NOT, { t98 }) }), t98, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_TRUE, { t99 }, nm->mkNode(Kind::NOT, { t99 }), e188, nm->mkNode(Kind::EQUAL, { t99,e189 }), Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_FALSE, { t100 }, nm->mkNode(Kind::NOT, { t100 }), e189, nm->mkNode(Kind::EQUAL, { t100,e188 }), Node::null());
db.addRule(ProofRewriteRule::BOOL_EQ_TRUE, { t101 }, nm->mkNode(Kind::EQUAL, { t101,e188 }), t101, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_EQ_FALSE, { t102 }, nm->mkNode(Kind::EQUAL, { t102,e189 }), nm->mkNode(Kind::NOT, { t102 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_EQ_NREFL, { x103 }, nm->mkNode(Kind::EQUAL, { x103,nm->mkNode(Kind::NOT, { x103 }) }), e189, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_FALSE1, { t104 }, nm->mkNode(Kind::IMPLIES, { t104,e189 }), nm->mkNode(Kind::NOT, { t104 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_FALSE2, { t105 }, nm->mkNode(Kind::IMPLIES, { e189,t105 }), e188, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_TRUE1, { t106 }, nm->mkNode(Kind::IMPLIES, { t106,e188 }), e188, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_TRUE2, { t107 }, nm->mkNode(Kind::IMPLIES, { e188,t107 }), t107, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_IMPL_ELIM, { t108, s109 }, nm->mkNode(Kind::IMPLIES, { t108,s109 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { t108 }),s109 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_TRUE, { xs110, ys111 }, nm->mkNode(Kind::OR, { xs110,e188,ys111 }), e188, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_FALSE, { xs112, ys113 }, nm->mkNode(Kind::OR, { xs112,e189,ys113 }), nm->mkNode(Kind::OR, { xs112,ys113 }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t180 }),t180 }));
db.addRule(ProofRewriteRule::BOOL_OR_FLATTEN, { xs114, b115, ys116, zs117 }, nm->mkNode(Kind::OR, { xs114,nm->mkNode(Kind::OR, { b115,ys116 }),zs117 }), nm->mkNode(Kind::OR, { xs114,b115,ys116,zs117 }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t181 }),t181 }));
db.addRule(ProofRewriteRule::BOOL_OR_DUP, { xs118, b119, ys120, zs121 }, nm->mkNode(Kind::OR, { xs118,b119,ys120,b119,zs121 }), nm->mkNode(Kind::OR, { xs118,b119,ys120,zs121 }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t182 }),t182 }));
db.addRule(ProofRewriteRule::BOOL_AND_TRUE, { xs122, ys123 }, nm->mkNode(Kind::AND, { xs122,e188,ys123 }), nm->mkNode(Kind::AND, { xs122,ys123 }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t183 }),t183 }));
db.addRule(ProofRewriteRule::BOOL_AND_FALSE, { xs124, ys125 }, nm->mkNode(Kind::AND, { xs124,e189,ys125 }), e189, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_AND_FLATTEN, { xs126, b127, ys128, zs129 }, nm->mkNode(Kind::AND, { xs126,nm->mkNode(Kind::AND, { b127,ys128 }),zs129 }), nm->mkNode(Kind::AND, { xs126,b127,ys128,zs129 }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t184 }),t184 }));
db.addRule(ProofRewriteRule::BOOL_AND_DUP, { xs130, b131, ys132, zs133 }, nm->mkNode(Kind::AND, { xs130,b131,ys132,b131,zs133 }), nm->mkNode(Kind::AND, { xs130,b131,ys132,zs133 }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t185 }),t185 }));
db.addRule(ProofRewriteRule::BOOL_AND_CONF, { xs134, w135, ys136, zs137 }, nm->mkNode(Kind::AND, { xs134,w135,ys136,nm->mkNode(Kind::NOT, { w135 }),zs137 }), e189, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_TAUT, { xs138, w139, ys140, zs141 }, nm->mkNode(Kind::OR, { xs138,w139,ys140,nm->mkNode(Kind::NOT, { w139 }),zs141 }), e188, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_OR_DE_MORGAN, { x142, y143, zs144 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::OR, { x142,y143,zs144 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::OR, { y143,zs144 }) }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t186 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { x142 }),t186 }) }));
db.addRule(ProofRewriteRule::BOOL_IMPLIES_DE_MORGAN, { x145, y146 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::IMPLIES, { x145,y146 }) }), nm->mkNode(Kind::AND, { x145,nm->mkNode(Kind::NOT, { y146 }) }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_AND_DE_MORGAN, { x147, y148, zs149 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::AND, { x147,y148,zs149 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::AND, { y148,zs149 }) }), e188, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t187 }),nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { x147 }),t187 }) }));
db.addRule(ProofRewriteRule::BOOL_XOR_REFL, { x150 }, nm->mkNode(Kind::XOR, { x150,x150 }), e189, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_NREFL, { x151 }, nm->mkNode(Kind::XOR, { x151,nm->mkNode(Kind::NOT, { x151 }) }), e188, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_FALSE, { x152 }, nm->mkNode(Kind::XOR, { x152,e189 }), x152, e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_TRUE, { x153 }, nm->mkNode(Kind::XOR, { x153,e188 }), nm->mkNode(Kind::NOT, { x153 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_COMM, { x154, y155 }, nm->mkNode(Kind::XOR, { x154,y155 }), nm->mkNode(Kind::XOR, { y155,x154 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_XOR_ELIM, { x156, y157 }, nm->mkNode(Kind::XOR, { x156,y157 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { x156 }),y157 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_XOR_ELIM, { x158, y159 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::XOR, { x158,y159 }) }), nm->mkNode(Kind::EQUAL, { x158,y159 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_EQ_ELIM, { x160, y161 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x160,y161 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { x160 }),y161 }), e188, Node::null());
db.addRule(ProofRewriteRule::ITE_NEG_BRANCH, { c162, x163, y164 }, nm->mkNode(Kind::ITE, { c162,x163,y164 }), nm->mkNode(Kind::EQUAL, { c162,x163 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { y164 }),x163 }), Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_TRUE, { c165, x166 }, nm->mkNode(Kind::ITE, { c165,e188,x166 }), nm->mkNode(Kind::OR, { c165,x166 }), e188, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_FALSE, { c167, x168 }, nm->mkNode(Kind::ITE, { c167,x168,e189 }), nm->mkNode(Kind::AND, { c167,x168 }), e188, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_FALSE, { c169, x170 }, nm->mkNode(Kind::ITE, { c169,e189,x170 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { c169 }),x170 }), e188, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_TRUE, { c171, x172 }, nm->mkNode(Kind::ITE, { c171,x172,e188 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { c171 }),x172 }), e188, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD_SELF, { c173, x174 }, nm->mkNode(Kind::ITE, { c173,c173,x174 }), nm->mkNode(Kind::ITE, { c173,e188,x174 }), e188, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD_SELF, { c175, x176 }, nm->mkNode(Kind::ITE, { c175,x176,c175 }), nm->mkNode(Kind::ITE, { c175,x176,e189 }), e188, Node::null());
db.addRule(ProofRewriteRule::BOOL_NOT_ITE_ELIM, { c177, x178, y179 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::ITE, { c177,x178,y179 }) }), nm->mkNode(Kind::ITE, { c177,nm->mkNode(Kind::NOT, { x178 }),nm->mkNode(Kind::NOT, { y179 }) }), e188, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
