/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_builtin_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x190 = nm->mkBoundVar("x190", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y191 = nm->mkBoundVar("y191", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x192 = nm->mkBoundVar("x192", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y193 = nm->mkBoundVar("y193", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c194 = nm->mkBoundVar("c194", nm->booleanType());
Node x195 = nm->mkBoundVar("x195", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y196 = nm->mkBoundVar("y196", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c197 = nm->mkBoundVar("c197", nm->booleanType());
Node x198 = nm->mkBoundVar("x198", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c199 = nm->mkBoundVar("c199", nm->booleanType());
Node x200 = nm->mkBoundVar("x200", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y201 = nm->mkBoundVar("y201", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z202 = nm->mkBoundVar("z202", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c203 = nm->mkBoundVar("c203", nm->booleanType());
Node x204 = nm->mkBoundVar("x204", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y205 = nm->mkBoundVar("y205", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z206 = nm->mkBoundVar("z206", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c207 = nm->mkBoundVar("c207", nm->booleanType());
Node x208 = nm->mkBoundVar("x208", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y209 = nm->mkBoundVar("y209", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z210 = nm->mkBoundVar("z210", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c211 = nm->mkBoundVar("c211", nm->booleanType());
Node x212 = nm->mkBoundVar("x212", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y213 = nm->mkBoundVar("y213", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z214 = nm->mkBoundVar("z214", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e215 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-builtin-rewrites.cpp
            db.addRule(ProofRewriteRule::ITE_TRUE_COND, { x190, y191 }, nm->mkNode(Kind::ITE, { e215,x190,y191 }), x190, e215, Node::null());
db.addRule(ProofRewriteRule::ITE_FALSE_COND, { x192, y193 }, nm->mkNode(Kind::ITE, { nm->mkConst(false),x192,y193 }), y193, e215, Node::null());
db.addRule(ProofRewriteRule::ITE_NOT_COND, { c194, x195, y196 }, nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c194 }),x195,y196 }), nm->mkNode(Kind::ITE, { c194,y196,x195 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_EQ_BRANCH, { c197, x198 }, nm->mkNode(Kind::ITE, { c197,x198,x198 }), x198, e215, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD, { c199, x200, y201, z202 }, nm->mkNode(Kind::ITE, { c199,nm->mkNode(Kind::ITE, { c199,x200,y201 }),z202 }), nm->mkNode(Kind::ITE, { c199,x200,z202 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD, { c203, x204, y205, z206 }, nm->mkNode(Kind::ITE, { c203,x204,nm->mkNode(Kind::ITE, { c203,y205,z206 }) }), nm->mkNode(Kind::ITE, { c203,x204,z206 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_THEN_NEG_LOOKAHEAD, { c207, x208, y209, z210 }, nm->mkNode(Kind::ITE, { c207,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c207 }),x208,y209 }),z210 }), nm->mkNode(Kind::ITE, { c207,y209,z210 }), e215, Node::null());
db.addRule(ProofRewriteRule::ITE_ELSE_NEG_LOOKAHEAD, { c211, x212, y213, z214 }, nm->mkNode(Kind::ITE, { c211,x212,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c211 }),y213,z214 }) }), nm->mkNode(Kind::ITE, { c211,x212,y213 }), e215, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
