/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node xs216 = nm->mkBoundVar("xs216", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs216);
Node s217 = nm->mkBoundVar("s217", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys218 = nm->mkBoundVar("ys218", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys218);
Node zs219 = nm->mkBoundVar("zs219", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs219);
Node t403 = nm->mkBoundVar("t403", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs220 = nm->mkBoundVar("xs220", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs220);
Node s221 = nm->mkBoundVar("s221", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys222 = nm->mkBoundVar("ys222", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys222);
Node i223 = nm->mkBoundVar("i223", nm->integerType());
Node j224 = nm->mkBoundVar("j224", nm->integerType());
Node j1225 = nm->mkBoundVar("j1225", nm->integerType());
Node k226 = nm->mkBoundVar("k226", nm->integerType());
Node x227 = nm->mkBoundVar("x227", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i228 = nm->mkBoundVar("i228", nm->integerType());
Node j229 = nm->mkBoundVar("j229", nm->integerType());
Node k230 = nm->mkBoundVar("k230", nm->integerType());
Node l231 = nm->mkBoundVar("l231", nm->integerType());
Node t404 = nm->mkBoundVar("t404", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x232 = nm->mkBoundVar("x232", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n233 = nm->mkBoundVar("n233", nm->integerType());
Node x234 = nm->mkBoundVar("x234", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs235 = nm->mkBoundVar("xs235", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs235);
Node y236 = nm->mkBoundVar("y236", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i237 = nm->mkBoundVar("i237", nm->integerType());
Node j238 = nm->mkBoundVar("j238", nm->integerType());
Node x239 = nm->mkBoundVar("x239", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs240 = nm->mkBoundVar("xs240", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs240);
Node y241 = nm->mkBoundVar("y241", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i242 = nm->mkBoundVar("i242", nm->integerType());
Node j243 = nm->mkBoundVar("j243", nm->integerType());
Node x244 = nm->mkBoundVar("x244", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y245 = nm->mkBoundVar("y245", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs246 = nm->mkBoundVar("xs246", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs246);
Node i247 = nm->mkBoundVar("i247", nm->integerType());
Node j248 = nm->mkBoundVar("j248", nm->integerType());
Node x249 = nm->mkBoundVar("x249", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y250 = nm->mkBoundVar("y250", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs251 = nm->mkBoundVar("xs251", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs251);
Node i252 = nm->mkBoundVar("i252", nm->integerType());
Node j253 = nm->mkBoundVar("j253", nm->integerType());
Node x254 = nm->mkBoundVar("x254", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y255 = nm->mkBoundVar("y255", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i256 = nm->mkBoundVar("i256", nm->integerType());
Node j257 = nm->mkBoundVar("j257", nm->integerType());
Node x258 = nm->mkBoundVar("x258", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y259 = nm->mkBoundVar("y259", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i260 = nm->mkBoundVar("i260", nm->integerType());
Node j261 = nm->mkBoundVar("j261", nm->integerType());
Node x262 = nm->mkBoundVar("x262", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y263 = nm->mkBoundVar("y263", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i264 = nm->mkBoundVar("i264", nm->integerType());
Node j265 = nm->mkBoundVar("j265", nm->integerType());
Node x266 = nm->mkBoundVar("x266", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i267 = nm->mkBoundVar("i267", nm->integerType());
Node j268 = nm->mkBoundVar("j268", nm->integerType());
Node x269 = nm->mkBoundVar("x269", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low270 = nm->mkBoundVar("low270", nm->integerType());
Node high271 = nm->mkBoundVar("high271", nm->integerType());
Node k272 = nm->mkBoundVar("k272", nm->integerType());
Node x273 = nm->mkBoundVar("x273", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low274 = nm->mkBoundVar("low274", nm->integerType());
Node high275 = nm->mkBoundVar("high275", nm->integerType());
Node k276 = nm->mkBoundVar("k276", nm->integerType());
Node x277 = nm->mkBoundVar("x277", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low278 = nm->mkBoundVar("low278", nm->integerType());
Node high279 = nm->mkBoundVar("high279", nm->integerType());
Node k280 = nm->mkBoundVar("k280", nm->integerType());
Node xs281 = nm->mkBoundVar("xs281", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys282 = nm->mkBoundVar("ys282", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n283 = nm->mkBoundVar("n283", nm->integerType());
Node m284 = nm->mkBoundVar("m284", nm->integerType());
Node x285 = nm->mkBoundVar("x285", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y286 = nm->mkBoundVar("y286", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node zs287 = nm->mkBoundVar("zs287", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs287);
Node t405 = nm->mkBoundVar("t405", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x288 = nm->mkBoundVar("x288", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n289 = nm->mkBoundVar("n289", nm->integerType());
Node m290 = nm->mkBoundVar("m290", nm->integerType());
Node x291 = nm->mkBoundVar("x291", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y292 = nm->mkBoundVar("y292", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n293 = nm->mkBoundVar("n293", nm->integerType());
Node m294 = nm->mkBoundVar("m294", nm->integerType());
Node x295 = nm->mkBoundVar("x295", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y296 = nm->mkBoundVar("y296", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n297 = nm->mkBoundVar("n297", nm->integerType());
Node m298 = nm->mkBoundVar("m298", nm->integerType());
Node x1299 = nm->mkBoundVar("x1299", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x2300 = nm->mkBoundVar("x2300", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y301 = nm->mkBoundVar("y301", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x1302 = nm->mkBoundVar("x1302", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x2303 = nm->mkBoundVar("x2303", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y304 = nm->mkBoundVar("y304", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x305 = nm->mkBoundVar("x305", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs306 = nm->mkBoundVar("xs306", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs306);
Node xs307 = nm->mkBoundVar("xs307", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs307);
Node ys308 = nm->mkBoundVar("ys308", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys308);
Node zs309 = nm->mkBoundVar("zs309", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs309);
Node x310 = nm->mkBoundVar("x310", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t406 = nm->mkBoundVar("t406", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs311 = nm->mkBoundVar("xs311", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs311);
Node ys312 = nm->mkBoundVar("ys312", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys312);
Node zs313 = nm->mkBoundVar("zs313", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs313);
Node x314 = nm->mkBoundVar("x314", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs315 = nm->mkBoundVar("xs315", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs315);
Node ys316 = nm->mkBoundVar("ys316", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys316);
Node zs317 = nm->mkBoundVar("zs317", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs317);
Node x318 = nm->mkBoundVar("x318", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t407 = nm->mkBoundVar("t407", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs319 = nm->mkBoundVar("xs319", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs319);
Node ys320 = nm->mkBoundVar("ys320", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys320);
Node zs321 = nm->mkBoundVar("zs321", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs321);
Node x322 = nm->mkBoundVar("x322", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs323 = nm->mkBoundVar("xs323", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs323);
Node ys324 = nm->mkBoundVar("ys324", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys324);
Node zs325 = nm->mkBoundVar("zs325", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs325);
Node x326 = nm->mkBoundVar("x326", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t408 = nm->mkBoundVar("t408", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs327 = nm->mkBoundVar("xs327", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs327);
Node ys328 = nm->mkBoundVar("ys328", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys328);
Node zs329 = nm->mkBoundVar("zs329", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs329);
Node x330 = nm->mkBoundVar("x330", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs331 = nm->mkBoundVar("xs331", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs331);
Node ys332 = nm->mkBoundVar("ys332", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys332);
Node zs333 = nm->mkBoundVar("zs333", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs333);
Node x334 = nm->mkBoundVar("x334", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x335 = nm->mkBoundVar("x335", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y336 = nm->mkBoundVar("y336", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c1337 = nm->mkBoundVar("c1337", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x338 = nm->mkBoundVar("x338", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i339 = nm->mkBoundVar("i339", nm->integerType());
Node m340 = nm->mkBoundVar("m340", nm->integerType());
Node n0341 = nm->mkBoundVar("n0341", nm->integerType());
Node x342 = nm->mkBoundVar("x342", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t343 = nm->mkBoundVar("t343", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node a344 = nm->mkBoundVar("a344", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n345 = nm->mkBoundVar("n345", nm->integerType());
Node m346 = nm->mkBoundVar("m346", nm->integerType());
Node x347 = nm->mkBoundVar("x347", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t348 = nm->mkBoundVar("t348", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node a349 = nm->mkBoundVar("a349", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n350 = nm->mkBoundVar("n350", nm->integerType());
Node m351 = nm->mkBoundVar("m351", nm->integerType());
Node x352 = nm->mkBoundVar("x352", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y353 = nm->mkBoundVar("y353", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x354 = nm->mkBoundVar("x354", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y355 = nm->mkBoundVar("y355", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x356 = nm->mkBoundVar("x356", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y357 = nm->mkBoundVar("y357", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x358 = nm->mkBoundVar("x358", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y359 = nm->mkBoundVar("y359", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x360 = nm->mkBoundVar("x360", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n361 = nm->mkBoundVar("n361", nm->integerType());
Node x362 = nm->mkBoundVar("x362", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c1363 = nm->mkBoundVar("c1363", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x364 = nm->mkBoundVar("x364", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0365 = nm->mkBoundVar("c0365", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x366 = nm->mkBoundVar("x366", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0367 = nm->mkBoundVar("c0367", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x368 = nm->mkBoundVar("x368", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x369 = nm->mkBoundVar("x369", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x370 = nm->mkBoundVar("x370", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x371 = nm->mkBoundVar("x371", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x372 = nm->mkBoundVar("x372", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y373 = nm->mkBoundVar("y373", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs374 = nm->mkBoundVar("xs374", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs374);
Node s375 = nm->mkBoundVar("s375", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys376 = nm->mkBoundVar("ys376", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys376);
Node zs377 = nm->mkBoundVar("zs377", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs377);
Node t409 = nm->mkBoundVar("t409", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs378 = nm->mkBoundVar("xs378", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs378);
Node s379 = nm->mkBoundVar("s379", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys380 = nm->mkBoundVar("ys380", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys380);
Node zs381 = nm->mkBoundVar("zs381", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs381);
Node t410 = nm->mkBoundVar("t410", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs382 = nm->mkBoundVar("xs382", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs382);
Node s383 = nm->mkBoundVar("s383", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys384 = nm->mkBoundVar("ys384", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys384);
Node zs385 = nm->mkBoundVar("zs385", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs385);
Node t411 = nm->mkBoundVar("t411", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs386 = nm->mkBoundVar("xs386", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs386);
Node s387 = nm->mkBoundVar("s387", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys388 = nm->mkBoundVar("ys388", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys388);
Node zs389 = nm->mkBoundVar("zs389", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs389);
Node t412 = nm->mkBoundVar("t412", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs390 = nm->mkBoundVar("xs390", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs390);
Node n1391 = nm->mkBoundVar("n1391", nm->integerType());
Node w1392 = nm->mkBoundVar("w1392", nm->integerType());
Node n2393 = nm->mkBoundVar("n2393", nm->integerType());
Node w2394 = nm->mkBoundVar("w2394", nm->integerType());
Node zs395 = nm->mkBoundVar("zs395", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs395);
Node t413 = nm->mkBoundVar("t413", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x396 = nm->mkBoundVar("x396", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y397 = nm->mkBoundVar("y397", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x398 = nm->mkBoundVar("x398", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y399 = nm->mkBoundVar("y399", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x400 = nm->mkBoundVar("x400", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x401 = nm->mkBoundVar("x401", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y402 = nm->mkBoundVar("y402", nm->mkAbstractType(Kind::BITVECTOR_TYPE));

  // Definitions
Node e414 = nm->mkConst(true);
Node e415 = nm->mkConstRealOrInt(Rational(0));
Node e416 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::BITVECTOR_SIZE, { a349 }) });
Node e417 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m351,a349 });
Node e418 = nm->mkNode(Kind::BITVECTOR_ADD, { x347,t348 });
Node e419 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(0)),nm->mkNode(Kind::BITVECTOR_SIZE, { a344 }) });
Node e420 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m346,a344 });
Node e421 = nm->mkNode(Kind::BITVECTOR_ADD, { x342,t343 });
Node e422 = nm->mkNode(Kind::BITVECTOR_SIZE, { x338 });
Node e423 = nm->mkConstRealOrInt(Rational(1));
Node e424 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n297,m298 });
Node e425 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n293,m294 });
Node e426 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x277 }),nm->mkConstRealOrInt(Rational(1)) });
Node e427 = nm->mkNode(Kind::BITVECTOR_SIZE, { x277 });
Node e428 = nm->mkNode(Kind::BITVECTOR_SIZE, { x273 });
Node e429 = nm->mkNode(Kind::BITVECTOR_CONCAT, { x249,xs251,y250 });
Node e430 = nm->mkNode(Kind::BITVECTOR_SIZE, { x244 });
Node e431 = nm->mkNode(Kind::BITVECTOR_SIZE, { x239 });

  // Rules

        {
            // from rewrites-bv-rewrites.cpp
            db.addRule(ProofRewriteRule::BV_CONCAT_FLATTEN, { xs216, s217, ys218, zs219 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs216,nm->mkNode(Kind::BITVECTOR_CONCAT, { s217,ys218 }),zs219 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs216,s217,ys218,zs219 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t403 }),t403 }));
db.addRule(ProofRewriteRule::BV_CONCAT_EXTRACT_MERGE, { xs220, s221, ys222, i223, j224, j1225, k226 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs220,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),k226,j1225,s221 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j224,i223,s221 }),ys222 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs220,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),k226,i223,s221 }),ys222 }), nm->mkNode(Kind::EQUAL, { j1225,nm->mkNode(Kind::ADD, { j224,e423 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_EXTRACT, { x227, i228, j229, k230, l231 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),l231,k230,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j229,i228,x227 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::ADD, { i228,l231 }),nm->mkNode(Kind::ADD, { i228,k230 }),x227 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t404 }),t404 }));
db.addRule(ProofRewriteRule::BV_EXTRACT_WHOLE, { x232, n233 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),n233,e415,x232 }), x232, nm->mkNode(Kind::GEQ, { n233,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x232 }),e423 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_1, { x234, xs235, y236, i237, j238 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j238,i237,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs235,y236,x234 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j238,i237,x234 }), nm->mkNode(Kind::LEQ, { j238,nm->mkNode(Kind::BITVECTOR_SIZE, { x234 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_2, { x239, xs240, y241, i242, j243 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j243,i242,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs240,y241,x239 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { j243,e431 }),e415,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs240,y241 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e431,e423 }),i242,x239 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { i242,e431 }),nm->mkNode(Kind::GEQ, { j243,e431 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_3, { x244, y245, xs246, i247, j248 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j248,i247,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs246,y245,x244 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { j248,e430 }),nm->mkNode(Kind::SUB, { i247,e430 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { xs246,y245 }) }), nm->mkNode(Kind::GEQ, { i247,e430 }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_4, { x249, y250, xs251, i252, j253 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j253,i252,e429 }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j253,i252,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs251,y250 }) }), nm->mkNode(Kind::LT, { j253,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e429 }),nm->mkNode(Kind::BITVECTOR_SIZE, { x249 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_BITWISE_AND, { x254, y255, i256, j257 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j257,i256,nm->mkNode(Kind::BITVECTOR_AND, { x254,y255 }) }), nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j257,i256,x254 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j257,i256,y255 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_BITWISE_OR, { x258, y259, i260, j261 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j261,i260,nm->mkNode(Kind::BITVECTOR_OR, { x258,y259 }) }), nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j261,i260,x258 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j261,i260,y259 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_BITWISE_XOR, { x262, y263, i264, j265 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j265,i264,nm->mkNode(Kind::BITVECTOR_XOR, { x262,y263 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j265,i264,x262 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j265,i264,y263 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_NOT, { x266, i267, j268 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j268,i267,nm->mkNode(Kind::BITVECTOR_NOT, { x266 }) }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j268,i267,x266 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_1, { x269, low270, high271, k272 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high271,low270,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k272,x269 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high271,low270,x269 }), nm->mkNode(Kind::LT, { high271,nm->mkNode(Kind::BITVECTOR_SIZE, { x269 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_2, { x273, low274, high275, k276 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high275,low274,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k276,x273 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),nm->mkNode(Kind::ADD, { e423,nm->mkNode(Kind::SUB, { high275,e428 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm->mkNode(Kind::SUB, { e428,e423 }),low274,x273 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { low274,e428 }),nm->mkNode(Kind::GEQ, { high275,e428 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_3, { x277, low278, high279, k280 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high279,low278,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k280,x277 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),nm->mkNode(Kind::ADD, { e423,nm->mkNode(Kind::SUB, { high279,low278 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),e426,e426,x277 }) }), nm->mkNode(Kind::GEQ, { low278,e427 }), Node::null());
db.addRule(ProofRewriteRule::BV_NEG_MULT, { xs281, ys282, n283, m284 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_MULT, { xs281,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n283,m284 }),ys282 }) }), nm->mkNode(Kind::BITVECTOR_MULT, { xs281,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::NEG, { n283 }),m284 }),ys282 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_NEG_ADD, { x285, y286, zs287 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_ADD, { x285,y286,zs287 }) }), nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_ADD, { y286,zs287 }) }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t405 }),nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_NEG, { x285 }),t405 }) }));
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_CONST_NEG, { x288, n289, m290 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_NEG, { x288 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n289,m290 }) }), nm->mkNode(Kind::BITVECTOR_MULT, { x288,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::NEG, { n289 }),m290 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_CONST_ADD, { x291, y292, n293, m294 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_ADD, { x291,y292 }),e425 }), nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_MULT, { x291,e425 }),nm->mkNode(Kind::BITVECTOR_MULT, { y292,e425 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_CONST_SUB, { x295, y296, n297, m298 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_SUB, { x295,y296 }),e424 }), nm->mkNode(Kind::BITVECTOR_SUB, { nm->mkNode(Kind::BITVECTOR_MULT, { x295,e424 }),nm->mkNode(Kind::BITVECTOR_MULT, { y296,e424 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_1, { x1299, x2300, y301 }, nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_ADD, { x1299,x2300 }),y301 }), nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_MULT, { x1299,y301 }),nm->mkNode(Kind::BITVECTOR_MULT, { x2300,y301 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_DISTRIB_2, { x1302, x2303, y304 }, nm->mkNode(Kind::BITVECTOR_MULT, { y304,nm->mkNode(Kind::BITVECTOR_ADD, { x1302,x2303 }) }), nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_MULT, { y304,x1302 }),nm->mkNode(Kind::BITVECTOR_MULT, { y304,x2303 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_XOR, { x305, xs306 }, nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { x305,xs306 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::BITVECTOR_NOT, { x305 }),xs306 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_AND_SIMPLIFY_1, { xs307, ys308, zs309, x310 }, nm->mkNode(Kind::BITVECTOR_AND, { xs307,x310,ys308,x310,zs309 }), nm->mkNode(Kind::BITVECTOR_AND, { xs307,x310,ys308,zs309 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t406 }),t406 }));
db.addRule(ProofRewriteRule::BV_AND_SIMPLIFY_2, { xs311, ys312, zs313, x314 }, nm->mkNode(Kind::BITVECTOR_AND, { xs311,x314,ys312,nm->mkNode(Kind::BITVECTOR_NOT, { x314 }),zs313 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { x314 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_OR_SIMPLIFY_1, { xs315, ys316, zs317, x318 }, nm->mkNode(Kind::BITVECTOR_OR, { xs315,x318,ys316,x318,zs317 }), nm->mkNode(Kind::BITVECTOR_OR, { xs315,x318,ys316,zs317 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t407 }),t407 }));
db.addRule(ProofRewriteRule::BV_OR_SIMPLIFY_2, { xs319, ys320, zs321, x322 }, nm->mkNode(Kind::BITVECTOR_OR, { xs319,x322,ys320,nm->mkNode(Kind::BITVECTOR_NOT, { x322 }),zs321 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { x322 }) }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_1, { xs323, ys324, zs325, x326 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs323,x326,ys324,x326,zs325 }), nm->mkNode(Kind::BITVECTOR_XOR, { xs323,ys324,zs325 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t408 }),t408 }));
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_2, { xs327, ys328, zs329, x330 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs327,x330,ys328,nm->mkNode(Kind::BITVECTOR_NOT, { x330 }),zs329 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs327,ys328,zs329 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_3, { xs331, ys332, zs333, x334 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs331,nm->mkNode(Kind::BITVECTOR_NOT, { x334 }),ys332,x334,zs333 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs331,ys332,zs333 }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ADD_ONE, { x335, y336, c1337 }, nm->mkNode(Kind::BITVECTOR_ULT, { x335,nm->mkNode(Kind::BITVECTOR_ADD, { y336,c1337 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { y336,x335 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { y336,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { y336 }) }) }) }) }) }), nm->mkNode(Kind::EQUAL, { c1337,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e423,nm->mkNode(Kind::BITVECTOR_SIZE, { c1337 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_CONCAT_TO_MULT, { x338, i339, m340, n0341 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),i339,n0341,x338 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n0341,m340 }) }), nm->mkNode(Kind::BITVECTOR_MULT, { x338,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e423,e422 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { m340,e422 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::ADD, { e423,i339,m340 }),e422 }),nm->mkNode(Kind::EQUAL, { n0341,e415 }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MULT_SLT_MULT_1, { x342, t343, a344, n345, m346 }, nm->mkNode(Kind::BITVECTOR_SLT, { nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n345,e421 }),e420 }),nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n345,x342 }),e420 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t343,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { t343 }) }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { a344,e419 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_SLT, { e421,x342 }),nm->mkNode(Kind::BITVECTOR_SGT, { a344,e419 }) }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_MULT_SLT_MULT_2, { x347, t348, a349, n350, m351 }, nm->mkNode(Kind::BITVECTOR_SLT, { nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n350,e418 }),e417 }),nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n350,x347 }),e417 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t348,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { t348 }) }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { a349,e416 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_ULT, { e418,x347 }),nm->mkNode(Kind::BITVECTOR_SGT, { a349,e416 }) }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_AND, { x352, y353 }, nm->mkNode(Kind::BITVECTOR_AND, { x352,y353 }), nm->mkNode(Kind::BITVECTOR_AND, { y353,x352 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_OR, { x354, y355 }, nm->mkNode(Kind::BITVECTOR_OR, { x354,y355 }), nm->mkNode(Kind::BITVECTOR_OR, { y355,x354 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_XOR, { x356, y357 }, nm->mkNode(Kind::BITVECTOR_XOR, { x356,y357 }), nm->mkNode(Kind::BITVECTOR_XOR, { y357,x356 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_MUL, { x358, y359 }, nm->mkNode(Kind::BITVECTOR_MULT, { x358,y359 }), nm->mkNode(Kind::BITVECTOR_MULT, { y359,x358 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_OR_ZERO, { x360, n361 }, nm->mkNode(Kind::BITVECTOR_OR, { x360,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,n361 }) }), x360, e414, Node::null());
db.addRule(ProofRewriteRule::BV_MUL_ONE, { x362, c1363 }, nm->mkNode(Kind::BITVECTOR_MULT, { x362,c1363 }), x362, nm->mkNode(Kind::EQUAL, { c1363,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e423,nm->mkNode(Kind::BITVECTOR_SIZE, { c1363 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_MUL_ZERO, { x364, c0365 }, nm->mkNode(Kind::BITVECTOR_MULT, { x364,c0365 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { x364 }) }), nm->mkNode(Kind::EQUAL, { c0365,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { c0365 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ADD_ZERO, { x366, c0367 }, nm->mkNode(Kind::BITVECTOR_ADD, { x366,c0367 }), x366, nm->mkNode(Kind::EQUAL, { c0367,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { c0367 }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_ADD_TWO, { x368 }, nm->mkNode(Kind::BITVECTOR_ADD, { x368,x368 }), nm->mkNode(Kind::BITVECTOR_MULT, { x368,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstRealOrInt(Rational(2)),nm->mkNode(Kind::BITVECTOR_SIZE, { x368 }) }) }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ELIMINATE_0, { x369 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e415,x369 }), x369, e414, Node::null());
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ELIMINATE_0, { x370 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),e415,x370 }), x370, e414, Node::null());
db.addRule(ProofRewriteRule::BV_NOT_NEQ, { x371 }, nm->mkNode(Kind::EQUAL, { x371,nm->mkNode(Kind::BITVECTOR_NOT, { x371 }) }), nm->mkConst(false), nm->mkNode(Kind::GT, { nm->mkNode(Kind::BITVECTOR_SIZE, { x371 }),e415 }), Node::null());
db.addRule(ProofRewriteRule::BV_ULT_ONES, { x372, y373 }, nm->mkNode(Kind::BITVECTOR_ULT, { x372,y373 }), nm->mkNode(Kind::DISTINCT, { x372,y373 }), nm->mkNode(Kind::EQUAL, { y373,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e415,nm->mkNode(Kind::BITVECTOR_SIZE, { y373 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::BV_OR_FLATTEN, { xs374, s375, ys376, zs377 }, nm->mkNode(Kind::BITVECTOR_OR, { xs374,nm->mkNode(Kind::BITVECTOR_OR, { s375,ys376 }),zs377 }), nm->mkNode(Kind::BITVECTOR_OR, { xs374,s375,ys376,zs377 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t409 }),t409 }));
db.addRule(ProofRewriteRule::BV_XOR_FLATTEN, { xs378, s379, ys380, zs381 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs378,nm->mkNode(Kind::BITVECTOR_XOR, { s379,ys380 }),zs381 }), nm->mkNode(Kind::BITVECTOR_XOR, { xs378,s379,ys380,zs381 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t410 }),t410 }));
db.addRule(ProofRewriteRule::BV_AND_FLATTEN, { xs382, s383, ys384, zs385 }, nm->mkNode(Kind::BITVECTOR_AND, { xs382,nm->mkNode(Kind::BITVECTOR_AND, { s383,ys384 }),zs385 }), nm->mkNode(Kind::BITVECTOR_AND, { xs382,s383,ys384,zs385 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t411 }),t411 }));
db.addRule(ProofRewriteRule::BV_MUL_FLATTEN, { xs386, s387, ys388, zs389 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs386,nm->mkNode(Kind::BITVECTOR_MULT, { s387,ys388 }),zs389 }), nm->mkNode(Kind::BITVECTOR_MULT, { xs386,s387,ys388,zs389 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t412 }),t412 }));
db.addRule(ProofRewriteRule::BV_CONCAT_MERGE_CONST, { xs390, n1391, w1392, n2393, w2394, zs395 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs390,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n1391,w1392 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n2393,w2394 }),zs395 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs390,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::ADD, { nm->mkNode(Kind::MULT, { n1391,nm->mkNode(Kind::POW2, { w2394 }) }),n2393 }),nm->mkNode(Kind::ADD, { w1392,w2394 }) }),zs395 }), e414, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t413 }),t413 }));
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_ADD, { x396, y397 }, nm->mkNode(Kind::BITVECTOR_ADD, { x396,y397 }), nm->mkNode(Kind::BITVECTOR_ADD, { y397,x396 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_NEG_SUB, { x398, y399 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_SUB, { x398,y399 }) }), nm->mkNode(Kind::BITVECTOR_SUB, { y399,x398 }), e414, Node::null());
db.addRule(ProofRewriteRule::BV_NEG_IDEMP, { x400 }, nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_NEG, { x400 }) }), x400, e414, Node::null());
db.addRule(ProofRewriteRule::BV_SUB_ELIMINATE, { x401, y402 }, nm->mkNode(Kind::BITVECTOR_SUB, { x401,y402 }), nm->mkNode(Kind::BITVECTOR_ADD, { x401,nm->mkNode(Kind::BITVECTOR_NEG, { y402 }) }), e414, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
