/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_strings_rewrites_regexp_membership(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t1134 = nm->mkBoundVar("t1134", nm->stringType());
Node t1135 = nm->mkBoundVar("t1135", nm->stringType());
Node t1136 = nm->mkBoundVar("t1136", nm->stringType());
Node t1137 = nm->mkBoundVar("t1137", nm->stringType());
Node s1138 = nm->mkBoundVar("s1138", nm->stringType());
Node t1139 = nm->mkBoundVar("t1139", nm->stringType());
Node r1140 = nm->mkBoundVar("r1140", nm->regExpType());
Node s1141 = nm->mkBoundVar("s1141", nm->stringType());
Node r11142 = nm->mkBoundVar("r11142", nm->regExpType());
Node r21143 = nm->mkBoundVar("r21143", nm->regExpType());
Node rs1144 = nm->mkBoundVar("rs1144", nm->regExpType());expr::markListVar(rs1144);
Node t1310 = nm->mkBoundVar("t1310", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1145 = nm->mkBoundVar("s1145", nm->stringType());
Node r11146 = nm->mkBoundVar("r11146", nm->regExpType());
Node r21147 = nm->mkBoundVar("r21147", nm->regExpType());
Node rs1148 = nm->mkBoundVar("rs1148", nm->regExpType());expr::markListVar(rs1148);
Node t1311 = nm->mkBoundVar("t1311", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1149 = nm->mkBoundVar("s1149", nm->stringType());
Node c11150 = nm->mkBoundVar("c11150", nm->stringType());
Node c21151 = nm->mkBoundVar("c21151", nm->stringType());
Node t1152 = nm->mkBoundVar("t1152", nm->stringType());
Node s1153 = nm->mkBoundVar("s1153", nm->stringType());
Node s1154 = nm->mkBoundVar("s1154", nm->stringType());
Node s11155 = nm->mkBoundVar("s11155", nm->stringType());
Node s21156 = nm->mkBoundVar("s21156", nm->stringType());expr::markListVar(s21156);
Node sr11157 = nm->mkBoundVar("sr11157", nm->stringType());
Node sr21158 = nm->mkBoundVar("sr21158", nm->stringType());expr::markListVar(sr21158);
Node r1159 = nm->mkBoundVar("r1159", nm->regExpType());expr::markListVar(r1159);
Node t1312 = nm->mkBoundVar("t1312", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1160 = nm->mkBoundVar("s1160", nm->stringType());
Node t1161 = nm->mkBoundVar("t1161", nm->stringType());
Node s11162 = nm->mkBoundVar("s11162", nm->stringType());
Node s21163 = nm->mkBoundVar("s21163", nm->stringType());expr::markListVar(s21163);
Node sr11164 = nm->mkBoundVar("sr11164", nm->stringType());
Node sr21165 = nm->mkBoundVar("sr21165", nm->stringType());expr::markListVar(sr21165);
Node r1166 = nm->mkBoundVar("r1166", nm->regExpType());expr::markListVar(r1166);
Node s1167 = nm->mkBoundVar("s1167", nm->stringType());
Node s11168 = nm->mkBoundVar("s11168", nm->stringType());
Node s21169 = nm->mkBoundVar("s21169", nm->stringType());expr::markListVar(s21169);
Node r11170 = nm->mkBoundVar("r11170", nm->regExpType());
Node r21171 = nm->mkBoundVar("r21171", nm->regExpType());expr::markListVar(r21171);
Node t1313 = nm->mkBoundVar("t1313", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1172 = nm->mkBoundVar("s1172", nm->stringType());
Node t1173 = nm->mkBoundVar("t1173", nm->stringType());
Node s11174 = nm->mkBoundVar("s11174", nm->stringType());
Node s21175 = nm->mkBoundVar("s21175", nm->stringType());expr::markListVar(s21175);
Node r11176 = nm->mkBoundVar("r11176", nm->regExpType());
Node r21177 = nm->mkBoundVar("r21177", nm->regExpType());expr::markListVar(r21177);
Node s1178 = nm->mkBoundVar("s1178", nm->stringType());
Node r11179 = nm->mkBoundVar("r11179", nm->regExpType());
Node r21180 = nm->mkBoundVar("r21180", nm->regExpType());expr::markListVar(r21180);
Node s1181 = nm->mkBoundVar("s1181", nm->stringType());
Node t1182 = nm->mkBoundVar("t1182", nm->stringType());
Node r11183 = nm->mkBoundVar("r11183", nm->regExpType());
Node r21184 = nm->mkBoundVar("r21184", nm->regExpType());expr::markListVar(r21184);
Node s1185 = nm->mkBoundVar("s1185", nm->stringType());
Node sr11186 = nm->mkBoundVar("sr11186", nm->stringType());
Node sr21187 = nm->mkBoundVar("sr21187", nm->stringType());expr::markListVar(sr21187);
Node r1188 = nm->mkBoundVar("r1188", nm->regExpType());expr::markListVar(r1188);
Node s1189 = nm->mkBoundVar("s1189", nm->stringType());
Node t1190 = nm->mkBoundVar("t1190", nm->stringType());
Node sr11191 = nm->mkBoundVar("sr11191", nm->stringType());
Node sr21192 = nm->mkBoundVar("sr21192", nm->stringType());expr::markListVar(sr21192);
Node r1193 = nm->mkBoundVar("r1193", nm->regExpType());expr::markListVar(r1193);
Node s1194 = nm->mkBoundVar("s1194", nm->stringType());
Node s11195 = nm->mkBoundVar("s11195", nm->stringType());
Node s21196 = nm->mkBoundVar("s21196", nm->stringType());expr::markListVar(s21196);
Node sr11197 = nm->mkBoundVar("sr11197", nm->stringType());
Node sr21198 = nm->mkBoundVar("sr21198", nm->stringType());expr::markListVar(sr21198);
Node t1314 = nm->mkBoundVar("t1314", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1199 = nm->mkBoundVar("s1199", nm->stringType());
Node t1200 = nm->mkBoundVar("t1200", nm->stringType());
Node s11201 = nm->mkBoundVar("s11201", nm->stringType());
Node s21202 = nm->mkBoundVar("s21202", nm->stringType());expr::markListVar(s21202);
Node sr11203 = nm->mkBoundVar("sr11203", nm->stringType());
Node sr21204 = nm->mkBoundVar("sr21204", nm->stringType());expr::markListVar(sr21204);
Node s1205 = nm->mkBoundVar("s1205", nm->stringType());
Node sr11206 = nm->mkBoundVar("sr11206", nm->stringType());
Node sr21207 = nm->mkBoundVar("sr21207", nm->stringType());expr::markListVar(sr21207);
Node s1208 = nm->mkBoundVar("s1208", nm->stringType());
Node t1209 = nm->mkBoundVar("t1209", nm->stringType());
Node sr11210 = nm->mkBoundVar("sr11210", nm->stringType());
Node sr21211 = nm->mkBoundVar("sr21211", nm->stringType());expr::markListVar(sr21211);
Node s1212 = nm->mkBoundVar("s1212", nm->stringType());
Node s11213 = nm->mkBoundVar("s11213", nm->stringType());
Node s21214 = nm->mkBoundVar("s21214", nm->stringType());expr::markListVar(s21214);
Node r11215 = nm->mkBoundVar("r11215", nm->regExpType());
Node r21216 = nm->mkBoundVar("r21216", nm->regExpType());expr::markListVar(r21216);
Node s1217 = nm->mkBoundVar("s1217", nm->stringType());
Node r11218 = nm->mkBoundVar("r11218", nm->regExpType());
Node r21219 = nm->mkBoundVar("r21219", nm->regExpType());expr::markListVar(r21219);
Node s1220 = nm->mkBoundVar("s1220", nm->stringType());
Node s11221 = nm->mkBoundVar("s11221", nm->stringType());
Node s21222 = nm->mkBoundVar("s21222", nm->stringType());expr::markListVar(s21222);
Node sr11223 = nm->mkBoundVar("sr11223", nm->stringType());
Node sr21224 = nm->mkBoundVar("sr21224", nm->stringType());expr::markListVar(sr21224);
Node r1225 = nm->mkBoundVar("r1225", nm->regExpType());expr::markListVar(r1225);
Node t1315 = nm->mkBoundVar("t1315", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1226 = nm->mkBoundVar("s1226", nm->stringType());
Node t1227 = nm->mkBoundVar("t1227", nm->stringType());
Node s11228 = nm->mkBoundVar("s11228", nm->stringType());
Node s21229 = nm->mkBoundVar("s21229", nm->stringType());expr::markListVar(s21229);
Node sr11230 = nm->mkBoundVar("sr11230", nm->stringType());
Node sr21231 = nm->mkBoundVar("sr21231", nm->stringType());expr::markListVar(sr21231);
Node r1232 = nm->mkBoundVar("r1232", nm->regExpType());expr::markListVar(r1232);
Node s1233 = nm->mkBoundVar("s1233", nm->stringType());
Node s11234 = nm->mkBoundVar("s11234", nm->stringType());
Node s21235 = nm->mkBoundVar("s21235", nm->stringType());expr::markListVar(s21235);
Node r11236 = nm->mkBoundVar("r11236", nm->regExpType());
Node r21237 = nm->mkBoundVar("r21237", nm->regExpType());expr::markListVar(r21237);
Node t1316 = nm->mkBoundVar("t1316", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1238 = nm->mkBoundVar("s1238", nm->stringType());
Node t1239 = nm->mkBoundVar("t1239", nm->stringType());
Node s11240 = nm->mkBoundVar("s11240", nm->stringType());
Node s21241 = nm->mkBoundVar("s21241", nm->stringType());expr::markListVar(s21241);
Node r11242 = nm->mkBoundVar("r11242", nm->regExpType());
Node r21243 = nm->mkBoundVar("r21243", nm->regExpType());expr::markListVar(r21243);
Node s1244 = nm->mkBoundVar("s1244", nm->stringType());
Node r11245 = nm->mkBoundVar("r11245", nm->regExpType());
Node r21246 = nm->mkBoundVar("r21246", nm->regExpType());expr::markListVar(r21246);
Node s1247 = nm->mkBoundVar("s1247", nm->stringType());
Node t1248 = nm->mkBoundVar("t1248", nm->stringType());
Node r11249 = nm->mkBoundVar("r11249", nm->regExpType());
Node r21250 = nm->mkBoundVar("r21250", nm->regExpType());expr::markListVar(r21250);
Node s1251 = nm->mkBoundVar("s1251", nm->stringType());
Node sr11252 = nm->mkBoundVar("sr11252", nm->stringType());
Node sr21253 = nm->mkBoundVar("sr21253", nm->stringType());expr::markListVar(sr21253);
Node r1254 = nm->mkBoundVar("r1254", nm->regExpType());expr::markListVar(r1254);
Node s1255 = nm->mkBoundVar("s1255", nm->stringType());
Node t1256 = nm->mkBoundVar("t1256", nm->stringType());
Node sr11257 = nm->mkBoundVar("sr11257", nm->stringType());
Node sr21258 = nm->mkBoundVar("sr21258", nm->stringType());expr::markListVar(sr21258);
Node r1259 = nm->mkBoundVar("r1259", nm->regExpType());expr::markListVar(r1259);
Node s1260 = nm->mkBoundVar("s1260", nm->stringType());
Node s11261 = nm->mkBoundVar("s11261", nm->stringType());
Node s21262 = nm->mkBoundVar("s21262", nm->stringType());expr::markListVar(s21262);
Node sr11263 = nm->mkBoundVar("sr11263", nm->stringType());
Node sr21264 = nm->mkBoundVar("sr21264", nm->stringType());expr::markListVar(sr21264);
Node t1317 = nm->mkBoundVar("t1317", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1265 = nm->mkBoundVar("s1265", nm->stringType());
Node t1266 = nm->mkBoundVar("t1266", nm->stringType());
Node s11267 = nm->mkBoundVar("s11267", nm->stringType());
Node s21268 = nm->mkBoundVar("s21268", nm->stringType());expr::markListVar(s21268);
Node sr11269 = nm->mkBoundVar("sr11269", nm->stringType());
Node sr21270 = nm->mkBoundVar("sr21270", nm->stringType());expr::markListVar(sr21270);
Node s1271 = nm->mkBoundVar("s1271", nm->stringType());
Node sr11272 = nm->mkBoundVar("sr11272", nm->stringType());
Node sr21273 = nm->mkBoundVar("sr21273", nm->stringType());expr::markListVar(sr21273);
Node s1274 = nm->mkBoundVar("s1274", nm->stringType());
Node t1275 = nm->mkBoundVar("t1275", nm->stringType());
Node sr11276 = nm->mkBoundVar("sr11276", nm->stringType());
Node sr21277 = nm->mkBoundVar("sr21277", nm->stringType());expr::markListVar(sr21277);
Node s1278 = nm->mkBoundVar("s1278", nm->stringType());
Node s11279 = nm->mkBoundVar("s11279", nm->stringType());
Node s21280 = nm->mkBoundVar("s21280", nm->stringType());expr::markListVar(s21280);
Node r11281 = nm->mkBoundVar("r11281", nm->regExpType());
Node r21282 = nm->mkBoundVar("r21282", nm->regExpType());expr::markListVar(r21282);
Node s1283 = nm->mkBoundVar("s1283", nm->stringType());
Node r11284 = nm->mkBoundVar("r11284", nm->regExpType());
Node r21285 = nm->mkBoundVar("r21285", nm->regExpType());expr::markListVar(r21285);
Node s1286 = nm->mkBoundVar("s1286", nm->stringType());
Node r11287 = nm->mkBoundVar("r11287", nm->regExpType());
Node r21288 = nm->mkBoundVar("r21288", nm->regExpType());
Node r31289 = nm->mkBoundVar("r31289", nm->regExpType());expr::markListVar(r31289);
Node s1290 = nm->mkBoundVar("s1290", nm->stringType());
Node r11291 = nm->mkBoundVar("r11291", nm->regExpType());
Node r21292 = nm->mkBoundVar("r21292", nm->regExpType());expr::markListVar(r21292);
Node r31293 = nm->mkBoundVar("r31293", nm->regExpType());
Node s1294 = nm->mkBoundVar("s1294", nm->stringType());
Node r11295 = nm->mkBoundVar("r11295", nm->regExpType());
Node r21296 = nm->mkBoundVar("r21296", nm->regExpType());
Node r31297 = nm->mkBoundVar("r31297", nm->regExpType());expr::markListVar(r31297);
Node s1298 = nm->mkBoundVar("s1298", nm->stringType());
Node r11299 = nm->mkBoundVar("r11299", nm->regExpType());
Node r21300 = nm->mkBoundVar("r21300", nm->regExpType());expr::markListVar(r21300);
Node r31301 = nm->mkBoundVar("r31301", nm->regExpType());
Node s1302 = nm->mkBoundVar("s1302", nm->stringType());
Node r11303 = nm->mkBoundVar("r11303", nm->regExpType());
Node r21304 = nm->mkBoundVar("r21304", nm->regExpType());
Node r31305 = nm->mkBoundVar("r31305", nm->regExpType());expr::markListVar(r31305);
Node s1306 = nm->mkBoundVar("s1306", nm->stringType());
Node r11307 = nm->mkBoundVar("r11307", nm->regExpType());
Node r21308 = nm->mkBoundVar("r21308", nm->regExpType());expr::markListVar(r21308);
Node r31309 = nm->mkBoundVar("r31309", nm->regExpType());

  // Definitions
Node e1318 = nm->mkNode(Kind::REGEXP_STAR, { r31309 });
Node e1319 = nm->mkConst(false);
Node e1320 = nm->mkNode(Kind::REGEXP_STAR, { r11303 });
Node e1321 = nm->mkNode(Kind::REGEXP_STAR, { r31301 });
Node e1322 = nm->mkNode(Kind::REGEXP_STAR, { r11295 });
Node e1323 = nm->mkNode(Kind::REGEXP_STAR, { r31293 });
Node e1324 = nm->mkNode(Kind::REGEXP_STAR, { r11287 });
Node e1325 = nm->mkNode(Kind::REGEXP_ALLCHAR, {  });
Node e1326 = nm->mkConstRealOrInt(Rational(1));
Node e1327 = nm->mkConst(String(""));
Node e1328 = nm->mkConst(true);
Node e1329 = nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_ALLCHAR, {  }) });
Node e1330 = nm->mkNode(Kind::STRING_TO_CODE, { s1149 });

  // Rules

        {
            // from rewrites-strings-rewrites-regexp-membership.cpp
            db.addRule(ProofRewriteRule::RE_IN_EMPTY, { t1134 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1134,nm->mkNode(Kind::REGEXP_NONE, {  }) }), e1319, e1328, Node::null());
db.addRule(ProofRewriteRule::RE_IN_SIGMA, { t1135 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1135,e1325 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t1135 }),e1326 }), e1328, Node::null());
db.addRule(ProofRewriteRule::RE_IN_SIGMA_STAR, { t1136 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1136,e1329 }), e1328, e1328, Node::null());
db.addRule(ProofRewriteRule::RE_IN_CSTRING, { t1137, s1138 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1137,nm->mkNode(Kind::STRING_TO_REGEXP, { s1138 }) }), nm->mkNode(Kind::EQUAL, { t1137,s1138 }), e1328, Node::null());
db.addRule(ProofRewriteRule::RE_IN_COMP, { t1139, r1140 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1139,nm->mkNode(Kind::REGEXP_COMPLEMENT, { r1140 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { t1139,r1140 }) }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_UNION_ELIM, { s1141, r11142, r21143, rs1144 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1141,nm->mkNode(Kind::REGEXP_UNION, { r11142,r21143,rs1144 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1141,nm->mkNode(Kind::REGEXP_UNION, { r21143,rs1144 }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1310 }),nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1141,r11142 }),t1310 }) }));
db.addRule(ProofRewriteRule::STR_IN_RE_INTER_ELIM, { s1145, r11146, r21147, rs1148 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1145,nm->mkNode(Kind::REGEXP_INTER, { r11146,r21147,rs1148 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1145,nm->mkNode(Kind::REGEXP_INTER, { r21147,rs1148 }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1311 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1145,r11146 }),t1311 }) }));
db.addRule(ProofRewriteRule::STR_IN_RE_RANGE_ELIM, { s1149, c11150, c21151 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1149,nm->mkNode(Kind::REGEXP_RANGE, { c11150,c21151 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::STRING_TO_CODE, { c11150 }),e1330 }),nm->mkNode(Kind::LEQ, { e1330,nm->mkNode(Kind::STRING_TO_CODE, { c21151 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { c11150 }),e1326 }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { c21151 }),e1326 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_CONTAINS, { t1152, s1153 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1152,nm->mkNode(Kind::REGEXP_CONCAT, { e1329,nm->mkNode(Kind::STRING_TO_REGEXP, { s1153 }),e1329 }) }), nm->mkNode(Kind::STRING_CONTAINS, { t1152,s1153 }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX, { s1154, s11155, s21156, sr11157, sr21158, r1159 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1154,s11155,s21156 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1154,sr11157,sr21158 }) }),r1159 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11155,s21156 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11157,sr21158 }) }),r1159 }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1312 }),t1312 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_NEG, { s1160, t1161, s11162, s21163, sr11164, sr21165, r1166 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1160,s11162,s21163 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1161,sr11164,sr21165 }) }),r1166 }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1160 }),nm->mkNode(Kind::STRING_LENGTH, { t1161 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1160,t1161 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE, { s1167, s11168, s21169, r11170, r21171 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1167,s11168,s21169 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { s1167 }),r11170,r21171 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11168,s21169 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11170,r21171 }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1313 }),t1313 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE_NEG, { s1172, t1173, s11174, s21175, r11176, r21177 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1172,s11174,s21175 }),nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { t1173 }),r11176,r21177 }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1172 }),nm->mkNode(Kind::STRING_LENGTH, { t1173 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1172,t1173 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE, { s1178, r11179, r21180 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1178,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { s1178 }),r11179,r21180 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::REGEXP_CONCAT, { r11179,r21180 }) }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE_NEG, { s1181, t1182, r11183, r21184 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1181,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { t1182 }),r11183,r21184 }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1181 }),nm->mkNode(Kind::STRING_LENGTH, { t1182 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1181,t1182 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE, { s1185, sr11186, sr21187, r1188 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1185,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1185,sr11186,sr21187 }) }),r1188 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11186,sr21187 }) }),r1188 }) }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE_NEG, { s1189, t1190, sr11191, sr21192, r1193 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1189,nm->mkNode(Kind::REGEXP_CONCAT, { nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1190,sr11191,sr21192 }) }),r1193 }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1189 }),nm->mkNode(Kind::STRING_LENGTH, { t1190 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1189,t1190 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE, { s1194, s11195, s21196, sr11197, sr21198 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1194,s11195,s21196 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1194,sr11197,sr21198 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11195,s21196 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11197,sr21198 }) }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1314 }),t1314 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_NEG, { s1199, t1200, s11201, s21202, sr11203, sr21204 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1199,s11201,s21202 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1200,sr11203,sr21204 }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1199 }),nm->mkNode(Kind::STRING_LENGTH, { t1200 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1199,t1200 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE, { s1205, sr11206, sr21207 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1205,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1205,sr11206,sr21207 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11206,sr21207 }) }) }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE_NEG, { s1208, t1209, sr11210, sr21211 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1208,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { t1209,sr11210,sr21211 }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1208 }),nm->mkNode(Kind::STRING_LENGTH, { t1209 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1208,t1209 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR, { s1212, s11213, s21214, r11215, r21216 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1212,s11213,s21214 }),nm->mkNode(Kind::REGEXP_CONCAT, { e1325,r11215,r21216 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11213,s21214 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11215,r21216 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1212 }),e1326 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR_S_SINGLE, { s1217, r11218, r21219 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1217,nm->mkNode(Kind::REGEXP_CONCAT, { e1325,r11218,r21219 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::REGEXP_CONCAT, { r11218,r21219 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1217 }),e1326 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_REV, { s1220, s11221, s21222, sr11223, sr21224, r1225 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11221,s21222,s1220 }),nm->mkNode(Kind::REGEXP_CONCAT, { r1225,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11223,sr21224,s1220 }) }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11221,s21222 }),nm->mkNode(Kind::REGEXP_CONCAT, { r1225,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11223,sr21224 }) }) }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1315 }),t1315 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_NEG_REV, { s1226, t1227, s11228, s21229, sr11230, sr21231, r1232 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11228,s21229,s1226 }),nm->mkNode(Kind::REGEXP_CONCAT, { r1232,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11230,sr21231,t1227 }) }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1226 }),nm->mkNode(Kind::STRING_LENGTH, { t1227 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1226,t1227 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE_REV, { s1233, s11234, s21235, r11236, r21237 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11234,s21235,s1233 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11236,r21237,nm->mkNode(Kind::STRING_TO_REGEXP, { s1233 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11234,s21235 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11236,r21237 }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1316 }),t1316 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SR_SINGLE_NEG_REV, { s1238, t1239, s11240, s21241, r11242, r21243 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11240,s21241,s1238 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11242,r21243,nm->mkNode(Kind::STRING_TO_REGEXP, { t1239 }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1238 }),nm->mkNode(Kind::STRING_LENGTH, { t1239 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1238,t1239 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE_REV, { s1244, r11245, r21246 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1244,nm->mkNode(Kind::REGEXP_CONCAT, { r11245,r21246,nm->mkNode(Kind::STRING_TO_REGEXP, { s1244 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::REGEXP_CONCAT, { r11245,r21246 }) }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_SRS_SINGLE_NEG_REV, { s1247, t1248, r11249, r21250 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1247,nm->mkNode(Kind::REGEXP_CONCAT, { r11249,r21250,nm->mkNode(Kind::STRING_TO_REGEXP, { t1248 }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1247 }),nm->mkNode(Kind::STRING_LENGTH, { t1248 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1247,t1248 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE_REV, { s1251, sr11252, sr21253, r1254 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1251,nm->mkNode(Kind::REGEXP_CONCAT, { r1254,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11252,sr21253,s1251 }) }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::REGEXP_CONCAT, { r1254,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11252,sr21253 }) }) }) }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_S_SINGLE_NEG_REV, { s1255, t1256, sr11257, sr21258, r1259 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1255,nm->mkNode(Kind::REGEXP_CONCAT, { r1259,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11257,sr21258,t1256 }) }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1255 }),nm->mkNode(Kind::STRING_LENGTH, { t1256 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1255,t1256 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_REV, { s1260, s11261, s21262, sr11263, sr21264 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11261,s21262,s1260 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11263,sr21264,s1260 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11261,s21262 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11263,sr21264 }) }) }), e1328, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1317 }),t1317 }));
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_NEG_REV, { s1265, t1266, s11267, s21268, sr11269, sr21270 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11267,s21268,s1265 }),nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11269,sr21270,t1266 }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1265 }),nm->mkNode(Kind::STRING_LENGTH, { t1266 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1265,t1266 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE_REV, { s1271, sr11272, sr21273 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1271,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11272,sr21273,s1271 }) }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11272,sr21273 }) }) }), e1328, Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_PREFIX_BASE_S_SINGLE_NEG_REV, { s1274, t1275, sr11276, sr21277 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1274,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { sr11276,sr21277,t1275 }) }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1274 }),nm->mkNode(Kind::STRING_LENGTH, { t1275 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1274,t1275 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR_REV, { s1278, s11279, s21280, r11281, r21282 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11279,s21280,s1278 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11281,r21282,e1325 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s11279,s21280 }),nm->mkNode(Kind::REGEXP_CONCAT, { r11281,r21282 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1278 }),e1326 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_STRIP_CHAR_S_SINGLE_REV, { s1283, r11284, r21285 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1283,nm->mkNode(Kind::REGEXP_CONCAT, { r11284,r21285,e1325 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { e1327,nm->mkNode(Kind::REGEXP_CONCAT, { r11284,r21285 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1283 }),e1326 }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_REQ_UNFOLD, { s1286, r11287, r21288, r31289 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1286,nm->mkNode(Kind::REGEXP_CONCAT, { e1324,r21288,r31289 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1286,nm->mkNode(Kind::REGEXP_CONCAT, { r11287,e1324,r21288,r31289 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1286,nm->mkNode(Kind::REGEXP_CONCAT, { r21288,r31289 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_REQ_UNFOLD_REV, { s1290, r11291, r21292, r31293 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1290,nm->mkNode(Kind::REGEXP_CONCAT, { r11291,r21292,e1323 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1290,nm->mkNode(Kind::REGEXP_CONCAT, { r11291,r21292,e1323,r31293 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1290,nm->mkNode(Kind::REGEXP_CONCAT, { r11291,r21292 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_SKIP_UNFOLD, { s1294, r11295, r21296, r31297 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1294,nm->mkNode(Kind::REGEXP_CONCAT, { e1322,r21296,r31297 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1294,nm->mkNode(Kind::REGEXP_CONCAT, { r21296,r31297 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1294,nm->mkNode(Kind::REGEXP_CONCAT, { r11295,e1322,r21296,r31297 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_SKIP_UNFOLD_REV, { s1298, r11299, r21300, r31301 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1298,nm->mkNode(Kind::REGEXP_CONCAT, { r11299,r21300,e1321 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1298,nm->mkNode(Kind::REGEXP_CONCAT, { r11299,r21300 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1298,nm->mkNode(Kind::REGEXP_CONCAT, { r11299,r21300,e1321,r31301 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_TEST_UNFOLD, { s1302, r11303, r21304, r31305 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1302,nm->mkNode(Kind::REGEXP_CONCAT, { e1320,r21304,r31305 }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1302,nm->mkNode(Kind::REGEXP_CONCAT, { r21304,r31305 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1302,nm->mkNode(Kind::REGEXP_CONCAT, { r11303,e1320,r21304,r31305 }) }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_IN_RE_TEST_UNFOLD_REV, { s1306, r11307, r21308, r31309 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1306,nm->mkNode(Kind::REGEXP_CONCAT, { r11307,r21308,e1318 }) }), e1319, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1306,nm->mkNode(Kind::REGEXP_CONCAT, { r11307,r21308 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1306,nm->mkNode(Kind::REGEXP_CONCAT, { r11307,r21308,e1318,r31309 }) }) }) }), Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
