/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_strings_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node x1854 = nm->mkBoundVar("x1854", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x1854);
Node x855 = nm->mkBoundVar("x855", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x2856 = nm->mkBoundVar("x2856", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x2856);
Node y857 = nm->mkBoundVar("y857", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x858 = nm->mkBoundVar("x858", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y859 = nm->mkBoundVar("y859", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x860 = nm->mkBoundVar("x860", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y861 = nm->mkBoundVar("y861", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node xs862 = nm->mkBoundVar("xs862", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(xs862);
Node s863 = nm->mkBoundVar("s863", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node ys864 = nm->mkBoundVar("ys864", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ys864);
Node zs865 = nm->mkBoundVar("zs865", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(zs865);
Node x866 = nm->mkBoundVar("x866", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1867 = nm->mkBoundVar("x1867", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x1867);
Node x2868 = nm->mkBoundVar("x2868", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x2868);
Node y869 = nm->mkBoundVar("y869", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x870 = nm->mkBoundVar("x870", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1871 = nm->mkBoundVar("x1871", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x1871);
Node x2872 = nm->mkBoundVar("x2872", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x2872);
Node y873 = nm->mkBoundVar("y873", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n874 = nm->mkBoundVar("n874", nm->integerType());
Node m875 = nm->mkBoundVar("m875", nm->integerType());
Node x876 = nm->mkBoundVar("x876", nm->stringType());
Node n877 = nm->mkBoundVar("n877", nm->integerType());
Node m878 = nm->mkBoundVar("m878", nm->integerType());
Node x879 = nm->mkBoundVar("x879", nm->stringType());
Node n880 = nm->mkBoundVar("n880", nm->integerType());
Node m881 = nm->mkBoundVar("m881", nm->integerType());
Node x882 = nm->mkBoundVar("x882", nm->stringType());
Node n883 = nm->mkBoundVar("n883", nm->integerType());
Node m884 = nm->mkBoundVar("m884", nm->integerType());
Node s885 = nm->mkBoundVar("s885", nm->stringType());
Node n886 = nm->mkBoundVar("n886", nm->integerType());
Node m887 = nm->mkBoundVar("m887", nm->integerType());
Node t888 = nm->mkBoundVar("t888", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s889 = nm->mkBoundVar("s889", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r890 = nm->mkBoundVar("r890", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t891 = nm->mkBoundVar("t891", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n892 = nm->mkBoundVar("n892", nm->integerType());
Node r893 = nm->mkBoundVar("r893", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s894 = nm->mkBoundVar("s894", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n895 = nm->mkBoundVar("n895", nm->integerType());
Node m896 = nm->mkBoundVar("m896", nm->integerType());
Node s897 = nm->mkBoundVar("s897", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n898 = nm->mkBoundVar("n898", nm->integerType());
Node m899 = nm->mkBoundVar("m899", nm->integerType());
Node k900 = nm->mkBoundVar("k900", nm->integerType());
Node s901 = nm->mkBoundVar("s901", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n902 = nm->mkBoundVar("n902", nm->integerType());
Node m903 = nm->mkBoundVar("m903", nm->integerType());
Node k904 = nm->mkBoundVar("k904", nm->integerType());
Node s1905 = nm->mkBoundVar("s1905", nm->stringType());
Node s2906 = nm->mkBoundVar("s2906", nm->stringType());expr::markListVar(s2906);
Node t1907 = nm->mkBoundVar("t1907", nm->stringType());
Node t2908 = nm->mkBoundVar("t2908", nm->stringType());expr::markListVar(t2908);
Node s1909 = nm->mkBoundVar("s1909", nm->stringType());
Node s2910 = nm->mkBoundVar("s2910", nm->stringType());expr::markListVar(s2910);
Node t1911 = nm->mkBoundVar("t1911", nm->stringType());
Node t2912 = nm->mkBoundVar("t2912", nm->stringType());expr::markListVar(t2912);
Node s1913 = nm->mkBoundVar("s1913", nm->stringType());
Node t1914 = nm->mkBoundVar("t1914", nm->stringType());
Node t2915 = nm->mkBoundVar("t2915", nm->stringType());expr::markListVar(t2915);
Node s1916 = nm->mkBoundVar("s1916", nm->stringType());
Node t1917 = nm->mkBoundVar("t1917", nm->stringType());
Node t2918 = nm->mkBoundVar("t2918", nm->stringType());expr::markListVar(t2918);
Node s1919 = nm->mkBoundVar("s1919", nm->stringType());
Node s2920 = nm->mkBoundVar("s2920", nm->stringType());
Node s3921 = nm->mkBoundVar("s3921", nm->stringType());expr::markListVar(s3921);
Node t2922 = nm->mkBoundVar("t2922", nm->stringType());
Node t3923 = nm->mkBoundVar("t3923", nm->stringType());expr::markListVar(t3923);
Node t1103 = nm->mkBoundVar("t1103", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1924 = nm->mkBoundVar("s1924", nm->stringType());
Node s2925 = nm->mkBoundVar("s2925", nm->stringType());
Node s3926 = nm->mkBoundVar("s3926", nm->stringType());expr::markListVar(s3926);
Node t2927 = nm->mkBoundVar("t2927", nm->stringType());
Node t3928 = nm->mkBoundVar("t3928", nm->stringType());expr::markListVar(t3928);
Node t1104 = nm->mkBoundVar("t1104", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s929 = nm->mkBoundVar("s929", nm->stringType());
Node t1930 = nm->mkBoundVar("t1930", nm->stringType());
Node t2931 = nm->mkBoundVar("t2931", nm->stringType());expr::markListVar(t2931);
Node s932 = nm->mkBoundVar("s932", nm->stringType());
Node t1933 = nm->mkBoundVar("t1933", nm->stringType());
Node t2934 = nm->mkBoundVar("t2934", nm->stringType());expr::markListVar(t2934);
Node s1935 = nm->mkBoundVar("s1935", nm->stringType());
Node s2936 = nm->mkBoundVar("s2936", nm->stringType());expr::markListVar(s2936);
Node s3937 = nm->mkBoundVar("s3937", nm->stringType());expr::markListVar(s3937);
Node t1938 = nm->mkBoundVar("t1938", nm->stringType());
Node t2939 = nm->mkBoundVar("t2939", nm->stringType());expr::markListVar(t2939);
Node t3940 = nm->mkBoundVar("t3940", nm->stringType());expr::markListVar(t3940);
Node s1941 = nm->mkBoundVar("s1941", nm->stringType());
Node s2942 = nm->mkBoundVar("s2942", nm->stringType());expr::markListVar(s2942);
Node s3943 = nm->mkBoundVar("s3943", nm->stringType());expr::markListVar(s3943);
Node t1944 = nm->mkBoundVar("t1944", nm->stringType());
Node t2945 = nm->mkBoundVar("t2945", nm->stringType());expr::markListVar(t2945);
Node t3946 = nm->mkBoundVar("t3946", nm->stringType());expr::markListVar(t3946);
Node s947 = nm->mkBoundVar("s947", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t948 = nm->mkBoundVar("t948", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s949 = nm->mkBoundVar("s949", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t950 = nm->mkBoundVar("t950", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s951 = nm->mkBoundVar("s951", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t952 = nm->mkBoundVar("t952", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s953 = nm->mkBoundVar("s953", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t954 = nm->mkBoundVar("t954", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s955 = nm->mkBoundVar("s955", nm->stringType());
Node n1956 = nm->mkBoundVar("n1956", nm->integerType());
Node m1957 = nm->mkBoundVar("m1957", nm->integerType());
Node n2958 = nm->mkBoundVar("n2958", nm->integerType());
Node m2959 = nm->mkBoundVar("m2959", nm->integerType());
Node s960 = nm->mkBoundVar("s960", nm->stringType());
Node n1961 = nm->mkBoundVar("n1961", nm->integerType());
Node m1962 = nm->mkBoundVar("m1962", nm->integerType());
Node n2963 = nm->mkBoundVar("n2963", nm->integerType());
Node m2964 = nm->mkBoundVar("m2964", nm->integerType());
Node s965 = nm->mkBoundVar("s965", nm->stringType());
Node n1966 = nm->mkBoundVar("n1966", nm->integerType());
Node m1967 = nm->mkBoundVar("m1967", nm->integerType());
Node n2968 = nm->mkBoundVar("n2968", nm->integerType());
Node m2969 = nm->mkBoundVar("m2969", nm->integerType());
Node s970 = nm->mkBoundVar("s970", nm->stringType());
Node n1971 = nm->mkBoundVar("n1971", nm->integerType());
Node m1972 = nm->mkBoundVar("m1972", nm->integerType());
Node n2973 = nm->mkBoundVar("n2973", nm->integerType());
Node m2974 = nm->mkBoundVar("m2974", nm->integerType());
Node s1975 = nm->mkBoundVar("s1975", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s2976 = nm->mkBoundVar("s2976", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s2976);
Node n977 = nm->mkBoundVar("n977", nm->integerType());
Node m978 = nm->mkBoundVar("m978", nm->integerType());
Node s1979 = nm->mkBoundVar("s1979", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s2980 = nm->mkBoundVar("s2980", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s3981 = nm->mkBoundVar("s3981", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s3981);
Node n982 = nm->mkBoundVar("n982", nm->integerType());
Node m983 = nm->mkBoundVar("m983", nm->integerType());
Node s984 = nm->mkBoundVar("s984", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n985 = nm->mkBoundVar("n985", nm->integerType());
Node s986 = nm->mkBoundVar("s986", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n987 = nm->mkBoundVar("n987", nm->integerType());
Node x988 = nm->mkBoundVar("x988", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node xs989 = nm->mkBoundVar("xs989", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(xs989);
Node z990 = nm->mkBoundVar("z990", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y991 = nm->mkBoundVar("y991", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node zs992 = nm->mkBoundVar("zs992", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(zs992);
Node x993 = nm->mkBoundVar("x993", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y994 = nm->mkBoundVar("y994", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z995 = nm->mkBoundVar("z995", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(z995);
Node w996 = nm->mkBoundVar("w996", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x997 = nm->mkBoundVar("x997", nm->stringType());
Node y998 = nm->mkBoundVar("y998", nm->stringType());
Node x999 = nm->mkBoundVar("x999", nm->stringType());
Node y1000 = nm->mkBoundVar("y1000", nm->stringType());
Node x1001 = nm->mkBoundVar("x1001", nm->stringType());
Node y1002 = nm->mkBoundVar("y1002", nm->stringType());
Node x1003 = nm->mkBoundVar("x1003", nm->stringType());
Node y1004 = nm->mkBoundVar("y1004", nm->stringType());
Node xs1005 = nm->mkBoundVar("xs1005", nm->stringType());expr::markListVar(xs1005);
Node ys1006 = nm->mkBoundVar("ys1006", nm->stringType());expr::markListVar(ys1006);
Node x1007 = nm->mkBoundVar("x1007", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1008 = nm->mkBoundVar("n1008", nm->integerType());
Node t1009 = nm->mkBoundVar("t1009", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1010 = nm->mkBoundVar("s1010", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1011 = nm->mkBoundVar("t1011", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1012 = nm->mkBoundVar("s1012", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1013 = nm->mkBoundVar("r1013", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1014 = nm->mkBoundVar("t1014", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1015 = nm->mkBoundVar("s1015", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s11016 = nm->mkBoundVar("s11016", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21017 = nm->mkBoundVar("s21017", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31018 = nm->mkBoundVar("s31018", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31018);
Node t1105 = nm->mkBoundVar("t1105", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1019 = nm->mkBoundVar("t1019", nm->stringType());
Node n1020 = nm->mkBoundVar("n1020", nm->integerType());
Node t1021 = nm->mkBoundVar("t1021", nm->stringType());
Node s1022 = nm->mkBoundVar("s1022", nm->stringType());
Node n1023 = nm->mkBoundVar("n1023", nm->integerType());
Node s11024 = nm->mkBoundVar("s11024", nm->stringType());
Node s21025 = nm->mkBoundVar("s21025", nm->stringType());
Node s31026 = nm->mkBoundVar("s31026", nm->stringType());expr::markListVar(s31026);
Node t1106 = nm->mkBoundVar("t1106", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s11027 = nm->mkBoundVar("s11027", nm->stringType());
Node s21028 = nm->mkBoundVar("s21028", nm->stringType());
Node s31029 = nm->mkBoundVar("s31029", nm->stringType());expr::markListVar(s31029);
Node t1107 = nm->mkBoundVar("t1107", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1030 = nm->mkBoundVar("s1030", nm->stringType());
Node s1031 = nm->mkBoundVar("s1031", nm->stringType());
Node x1032 = nm->mkBoundVar("x1032", nm->regExpType());
Node x1033 = nm->mkBoundVar("x1033", nm->regExpType());
Node y1034 = nm->mkBoundVar("y1034", nm->regExpType());
Node xs1035 = nm->mkBoundVar("xs1035", nm->regExpType());expr::markListVar(xs1035);
Node ys1036 = nm->mkBoundVar("ys1036", nm->regExpType());expr::markListVar(ys1036);
Node xs1037 = nm->mkBoundVar("xs1037", nm->regExpType());expr::markListVar(xs1037);
Node ys1038 = nm->mkBoundVar("ys1038", nm->regExpType());expr::markListVar(ys1038);
Node xs1039 = nm->mkBoundVar("xs1039", nm->regExpType());expr::markListVar(xs1039);
Node s1040 = nm->mkBoundVar("s1040", nm->regExpType());
Node ys1041 = nm->mkBoundVar("ys1041", nm->regExpType());expr::markListVar(ys1041);
Node zs1042 = nm->mkBoundVar("zs1042", nm->regExpType());expr::markListVar(zs1042);
Node xs1043 = nm->mkBoundVar("xs1043", nm->regExpType());expr::markListVar(xs1043);
Node r1044 = nm->mkBoundVar("r1044", nm->regExpType());
Node ys1045 = nm->mkBoundVar("ys1045", nm->regExpType());expr::markListVar(ys1045);
Node xs1046 = nm->mkBoundVar("xs1046", nm->regExpType());expr::markListVar(xs1046);
Node s1047 = nm->mkBoundVar("s1047", nm->stringType());
Node t1048 = nm->mkBoundVar("t1048", nm->stringType());
Node ys1049 = nm->mkBoundVar("ys1049", nm->regExpType());expr::markListVar(ys1049);
Node t1108 = nm->mkBoundVar("t1108", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1050 = nm->mkBoundVar("xs1050", nm->regExpType());expr::markListVar(xs1050);
Node ys1051 = nm->mkBoundVar("ys1051", nm->regExpType());expr::markListVar(ys1051);
Node xs1052 = nm->mkBoundVar("xs1052", nm->regExpType());expr::markListVar(xs1052);
Node ys1053 = nm->mkBoundVar("ys1053", nm->regExpType());expr::markListVar(ys1053);
Node t1109 = nm->mkBoundVar("t1109", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1054 = nm->mkBoundVar("xs1054", nm->regExpType());expr::markListVar(xs1054);
Node b1055 = nm->mkBoundVar("b1055", nm->regExpType());
Node ys1056 = nm->mkBoundVar("ys1056", nm->regExpType());expr::markListVar(ys1056);
Node zs1057 = nm->mkBoundVar("zs1057", nm->regExpType());expr::markListVar(zs1057);
Node t1110 = nm->mkBoundVar("t1110", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1058 = nm->mkBoundVar("xs1058", nm->regExpType());expr::markListVar(xs1058);
Node b1059 = nm->mkBoundVar("b1059", nm->regExpType());
Node ys1060 = nm->mkBoundVar("ys1060", nm->regExpType());expr::markListVar(ys1060);
Node zs1061 = nm->mkBoundVar("zs1061", nm->regExpType());expr::markListVar(zs1061);
Node t1111 = nm->mkBoundVar("t1111", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1062 = nm->mkBoundVar("xs1062", nm->regExpType());expr::markListVar(xs1062);
Node ys1063 = nm->mkBoundVar("ys1063", nm->regExpType());expr::markListVar(ys1063);
Node t1112 = nm->mkBoundVar("t1112", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1064 = nm->mkBoundVar("xs1064", nm->regExpType());expr::markListVar(xs1064);
Node ys1065 = nm->mkBoundVar("ys1065", nm->regExpType());expr::markListVar(ys1065);
Node xs1066 = nm->mkBoundVar("xs1066", nm->regExpType());expr::markListVar(xs1066);
Node b1067 = nm->mkBoundVar("b1067", nm->regExpType());
Node ys1068 = nm->mkBoundVar("ys1068", nm->regExpType());expr::markListVar(ys1068);
Node zs1069 = nm->mkBoundVar("zs1069", nm->regExpType());expr::markListVar(zs1069);
Node t1113 = nm->mkBoundVar("t1113", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1070 = nm->mkBoundVar("xs1070", nm->regExpType());expr::markListVar(xs1070);
Node b1071 = nm->mkBoundVar("b1071", nm->regExpType());
Node ys1072 = nm->mkBoundVar("ys1072", nm->regExpType());expr::markListVar(ys1072);
Node zs1073 = nm->mkBoundVar("zs1073", nm->regExpType());expr::markListVar(zs1073);
Node t1114 = nm->mkBoundVar("t1114", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node n1074 = nm->mkBoundVar("n1074", nm->integerType());
Node m1075 = nm->mkBoundVar("m1075", nm->integerType());
Node r1076 = nm->mkBoundVar("r1076", nm->regExpType());
Node xs1077 = nm->mkBoundVar("xs1077", nm->regExpType());expr::markListVar(xs1077);
Node ys1078 = nm->mkBoundVar("ys1078", nm->regExpType());expr::markListVar(ys1078);
Node s1079 = nm->mkBoundVar("s1079", nm->stringType());
Node xs1080 = nm->mkBoundVar("xs1080", nm->regExpType());expr::markListVar(xs1080);
Node ys1081 = nm->mkBoundVar("ys1081", nm->regExpType());expr::markListVar(ys1081);
Node s1082 = nm->mkBoundVar("s1082", nm->stringType());
Node s1083 = nm->mkBoundVar("s1083", nm->stringType());
Node n1084 = nm->mkBoundVar("n1084", nm->integerType());
Node s11085 = nm->mkBoundVar("s11085", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21086 = nm->mkBoundVar("s21086", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21086);
Node n1087 = nm->mkBoundVar("n1087", nm->integerType());
Node s11088 = nm->mkBoundVar("s11088", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21089 = nm->mkBoundVar("s21089", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31090 = nm->mkBoundVar("s31090", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31090);
Node n1091 = nm->mkBoundVar("n1091", nm->integerType());
Node s11092 = nm->mkBoundVar("s11092", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21093 = nm->mkBoundVar("s21093", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31094 = nm->mkBoundVar("s31094", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31094);
Node n1095 = nm->mkBoundVar("n1095", nm->integerType());
Node m1096 = nm->mkBoundVar("m1096", nm->integerType());
Node x1097 = nm->mkBoundVar("x1097", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1098 = nm->mkBoundVar("y1098", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(y1098);
Node z1099 = nm->mkBoundVar("z1099", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1115 = nm->mkBoundVar("t1115", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1100 = nm->mkBoundVar("x1100", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1101 = nm->mkBoundVar("x1101", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1102 = nm->mkBoundVar("x1102", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e1116 = nm->mkNode(Kind::SEQ_UNIT, { x1102 });
Node e1117 = nm->mkConst(true);
Node e1118 = nm->mkNode(Kind::STRING_LENGTH, { s11092 });
Node e1119 = nm->mkConstRealOrInt(Rational(0));
Node e1120 = nm->mkNode(Kind::STRING_LENGTH, { s11088 });
Node e1121 = nm->mkConstRealOrInt(Rational(1));
Node e1122 = nm->mkNode(Kind::STRING_TO_REGEXP, { s1079 });
Node e1123 = nm->mkNode(Kind::REGEXP_NONE, {  });
Node e1124 = nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_ALLCHAR, {  }) });
Node e1125 = nm->mkNode(Kind::REGEXP_STAR, { r1044 });
Node e1126 = nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkConst(String("")) });
Node e1127 = nm->mkConst(String(""));
Node e1128 = nm->mkNode(Kind::STRING_LENGTH, { s1979 });
Node e1129 = nm->mkNode(Kind::STRING_SUBSTR, { s970,n1971,m1972 });
Node e1130 = nm->mkNode(Kind::STRING_SUBSTR, { s965,n1966,m1967 });
Node e1131 = nm->mkNode(Kind::SUB, { m1957,n2958 });
Node e1132 = nm->mkNode(Kind::STRING_LENGTH, { s949 });
Node e1133 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-strings-rewrites.cpp
            db.addRule(ProofRewriteRule::STR_EQ_CTN_FALSE, { x1854, x855, x2856, y857 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { x1854,x855,x2856 }),y857 }), e1133, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { y857,x855 }),e1133 }), Node::null());
db.addRule(ProofRewriteRule::STR_EQ_CTN_FULL_FALSE1, { x858, y859 }, nm->mkNode(Kind::EQUAL, { x858,y859 }), e1133, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { y859,x858 }),e1133 }), Node::null());
db.addRule(ProofRewriteRule::STR_EQ_CTN_FULL_FALSE2, { x860, y861 }, nm->mkNode(Kind::EQUAL, { x860,y861 }), e1133, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { x860,y861 }),e1133 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_FLATTEN, { xs862, s863, ys864, zs865 }, nm->mkNode(Kind::STRING_CONCAT, { xs862,nm->mkNode(Kind::STRING_CONCAT, { s863,ys864 }),zs865 }), nm->mkNode(Kind::STRING_CONCAT, { xs862,s863,ys864,zs865 }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_FLATTEN_EQ, { x866, x1867, x2868, y869 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_CONCAT, { x866,x1867 }),x2868 }),y869 }), nm->mkNode(Kind::EQUAL, { y869,nm->mkNode(Kind::STRING_CONCAT, { x866,x1867,x2868 }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_FLATTEN_EQ_REV, { x870, x1871, x2872, y873 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { x2872,nm->mkNode(Kind::STRING_CONCAT, { x1871,x870 }) }),y873 }), nm->mkNode(Kind::EQUAL, { y873,nm->mkNode(Kind::STRING_CONCAT, { x2872,x1871,x870 }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_STR, { n874, m875 }, nm->mkNode(Kind::STRING_SUBSTR, { e1127,n874,m875 }), e1127, e1117, Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_RANGE, { x876, n877, m878 }, nm->mkNode(Kind::STRING_SUBSTR, { x876,n877,m878 }), e1127, nm->mkNode(Kind::GEQ, { e1119,m878 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_START, { x879, n880, m881 }, nm->mkNode(Kind::STRING_SUBSTR, { x879,n880,m881 }), e1127, nm->mkNode(Kind::GEQ, { n880,nm->mkNode(Kind::STRING_LENGTH, { x879 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_START_NEG, { x882, n883, m884 }, nm->mkNode(Kind::STRING_SUBSTR, { x882,n883,m884 }), e1127, nm->mkNode(Kind::LT, { n883,e1119 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_EQ_EMPTY, { s885, n886, m887 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_SUBSTR, { s885,n886,m887 }),e1127 }), nm->mkNode(Kind::EQUAL, { s885,e1127 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { n886,e1119 }),nm->mkNode(Kind::GT, { m887,n886 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_REPLACE_INV, { t888, s889, r890 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_REPLACE, { t888,s889,r890 }) }), nm->mkNode(Kind::STRING_LENGTH, { t888 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s889 }),nm->mkNode(Kind::STRING_LENGTH, { r890 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_UPDATE_INV, { t891, n892, r893 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_UPDATE, { t891,n892,r893 }) }), nm->mkNode(Kind::STRING_LENGTH, { t891 }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_LEN_SUBSTR_IN_RANGE, { s894, n895, m896 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_SUBSTR, { s894,n895,m896 }) }), m896, nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n895,e1119 }),nm->mkNode(Kind::GEQ, { m896,e1119 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s894 }),nm->mkNode(Kind::ADD, { n895,m896 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_SUBSTR_UB1, { s897, n898, m899, k900 }, nm->mkNode(Kind::GEQ, { k900,nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_SUBSTR, { s897,n898,m899 }) }) }), e1117, nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { k900,e1119 }),nm->mkNode(Kind::GEQ, { k900,m899 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_LEN_SUBSTR_UB2, { s901, n902, m903, k904 }, nm->mkNode(Kind::GEQ, { k904,nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_SUBSTR, { s901,n902,m903 }) }) }), e1117, nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { k904,e1119 }),nm->mkNode(Kind::GEQ, { k904,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::STRING_LENGTH, { s901 }),n902 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH, { s1905, s2906, t1907, t2908 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s1905,s2906 }),nm->mkNode(Kind::STRING_CONCAT, { t1907,t2908 }) }), e1133, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1905,t1907 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1905 }),nm->mkNode(Kind::STRING_LENGTH, { t1907 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH_REV, { s1909, s2910, t1911, t2912 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2910,s1909 }),nm->mkNode(Kind::STRING_CONCAT, { t2912,t1911 }) }), e1133, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1909,t1911 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1909 }),nm->mkNode(Kind::STRING_LENGTH, { t1911 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH2, { s1913, t1914, t2915 }, nm->mkNode(Kind::EQUAL, { s1913,nm->mkNode(Kind::STRING_CONCAT, { t1914,t2915 }) }), e1133, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1913,t1914 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1913 }),nm->mkNode(Kind::STRING_LENGTH, { t1914 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH2_REV, { s1916, t1917, t2918 }, nm->mkNode(Kind::EQUAL, { s1916,nm->mkNode(Kind::STRING_CONCAT, { t2918,t1917 }) }), e1133, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1916,t1917 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1916 }),nm->mkNode(Kind::STRING_LENGTH, { t1917 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY, { s1919, s2920, s3921, t2922, t3923 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s1919,s2920,s3921 }),nm->mkNode(Kind::STRING_CONCAT, { s1919,t2922,t3923 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2920,s3921 }),nm->mkNode(Kind::STRING_CONCAT, { t2922,t3923 }) }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1103 }),t1103 }));
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_REV, { s1924, s2925, s3926, t2927, t3928 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2925,s3926,s1924 }),nm->mkNode(Kind::STRING_CONCAT, { t2927,t3928,s1924 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2925,s3926 }),nm->mkNode(Kind::STRING_CONCAT, { t2927,t3928 }) }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1104 }),t1104 }));
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_BASE, { s929, t1930, t2931 }, nm->mkNode(Kind::EQUAL, { s929,nm->mkNode(Kind::STRING_CONCAT, { s929,t1930,t2931 }) }), nm->mkNode(Kind::EQUAL, { e1127,nm->mkNode(Kind::STRING_CONCAT, { t1930,t2931 }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_BASE_REV, { s932, t1933, t2934 }, nm->mkNode(Kind::EQUAL, { s932,nm->mkNode(Kind::STRING_CONCAT, { t1933,t2934,s932 }) }), nm->mkNode(Kind::EQUAL, { e1127,nm->mkNode(Kind::STRING_CONCAT, { t1933,t2934 }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH_CHAR, { s1935, s2936, s3937, t1938, t2939, t3940 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_CONCAT, { s1935,s2936 }),s3937 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_CONCAT, { t1938,t2939 }),t3940 }) }), e1133, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1935,t1938 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1935 }),nm->mkNode(Kind::STRING_LENGTH, { t1938 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH_CHAR_REV, { s1941, s2942, s3943, t1944, t2945, t3946 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s3943,nm->mkNode(Kind::STRING_CONCAT, { s2942,s1941 }) }),nm->mkNode(Kind::STRING_CONCAT, { t3946,nm->mkNode(Kind::STRING_CONCAT, { t2945,t1944 }) }) }), e1133, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1941,t1944 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1941 }),nm->mkNode(Kind::STRING_LENGTH, { t1944 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_PREFIXOF_ELIM, { s947, t948 }, nm->mkNode(Kind::STRING_PREFIX, { s947,t948 }), nm->mkNode(Kind::EQUAL, { s947,nm->mkNode(Kind::STRING_SUBSTR, { t948,e1119,nm->mkNode(Kind::STRING_LENGTH, { s947 }) }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_SUFFIXOF_ELIM, { s949, t950 }, nm->mkNode(Kind::STRING_SUFFIX, { s949,t950 }), nm->mkNode(Kind::EQUAL, { s949,nm->mkNode(Kind::STRING_SUBSTR, { t950,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::STRING_LENGTH, { t950 }),e1132 }),e1132 }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_PREFIXOF_ONE, { s951, t952 }, nm->mkNode(Kind::STRING_PREFIX, { s951,t952 }), nm->mkNode(Kind::STRING_CONTAINS, { t952,s951 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t952 }),e1121 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUFFIXOF_ONE, { s953, t954 }, nm->mkNode(Kind::STRING_SUFFIX, { s953,t954 }), nm->mkNode(Kind::STRING_CONTAINS, { t954,s953 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t954 }),e1121 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE1, { s955, n1956, m1957, n2958, m2959 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_SUBSTR, { s955,n1956,m1957 }),n2958,m2959 }), nm->mkNode(Kind::STRING_SUBSTR, { s955,nm->mkNode(Kind::ADD, { n1956,n2958 }),e1131 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1956,e1119 }),nm->mkNode(Kind::GEQ, { n2958,e1119 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { m2959,e1131 }),e1119 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE2, { s960, n1961, m1962, n2963, m2964 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_SUBSTR, { s960,n1961,m1962 }),n2963,m2964 }), nm->mkNode(Kind::STRING_SUBSTR, { s960,nm->mkNode(Kind::ADD, { n1961,n2963 }),m2964 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1961,e1119 }),nm->mkNode(Kind::GEQ, { n2963,e1119 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { m1962,n2963 }),m2964 }),e1119 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE3, { s965, n1966, m1967, n2968, m2969 }, nm->mkNode(Kind::STRING_SUBSTR, { e1130,n2968,m2969 }), nm->mkNode(Kind::STRING_SUBSTR, { s965,nm->mkNode(Kind::ADD, { n1966,n2968 }),m2969 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1966,e1119 }),nm->mkNode(Kind::GEQ, { n2968,e1119 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { e1130 }),nm->mkNode(Kind::ADD, { n2968,m2969 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE4, { s970, n1971, m1972, n2973, m2974 }, nm->mkNode(Kind::STRING_SUBSTR, { e1129,n2973,m2974 }), nm->mkNode(Kind::STRING_SUBSTR, { s970,nm->mkNode(Kind::ADD, { n1971,n2973 }),nm->mkNode(Kind::SUB, { m1972,n2973 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1971,e1119 }),nm->mkNode(Kind::GEQ, { n2973,e1119 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::ADD, { n2973,m2974 }),nm->mkNode(Kind::STRING_LENGTH, { e1129 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_CONCAT1, { s1975, s2976, n977, m978 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s1975,s2976 }),n977,m978 }), nm->mkNode(Kind::STRING_SUBSTR, { s1975,n977,m978 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n977,e1119 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s1975 }),nm->mkNode(Kind::ADD, { n977,m978 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_CONCAT2, { s1979, s2980, s3981, n982, m983 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s1979,s2980,s3981 }),n982,m983 }), nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s2980,s3981 }),nm->mkNode(Kind::SUB, { n982,e1128 }),m983 }), nm->mkNode(Kind::GEQ, { n982,e1128 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_FULL, { s984, n985 }, nm->mkNode(Kind::STRING_SUBSTR, { s984,e1119,n985 }), s984, nm->mkNode(Kind::GEQ, { n985,nm->mkNode(Kind::STRING_LENGTH, { s984 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_FULL_EQ, { s986, n987 }, nm->mkNode(Kind::STRING_SUBSTR, { s986,e1119,n987 }), s986, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s986 }),n987 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_REFL, { x988 }, nm->mkNode(Kind::STRING_CONTAINS, { x988,x988 }), e1117, e1117, Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_CONCAT_FIND, { xs989, z990, y991, zs992 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { xs989,z990,zs992 }),y991 }), e1117, nm->mkNode(Kind::STRING_CONTAINS, { z990,y991 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_SPLIT_CHAR, { x993, y994, z995, w996 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { x993,y994,z995 }),w996 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_CONTAINS, { x993,w996 }),nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { y994,z995 }),w996 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { w996 }),e1121 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_LT_LEN, { x997, y998 }, nm->mkNode(Kind::STRING_CONTAINS, { x997,y998 }), e1133, nm->mkNode(Kind::GT, { nm->mkNode(Kind::STRING_LENGTH, { y998 }),nm->mkNode(Kind::STRING_LENGTH, { x997 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_LEQ_LEN_EQ, { x999, y1000 }, nm->mkNode(Kind::STRING_CONTAINS, { x999,y1000 }), nm->mkNode(Kind::EQUAL, { x999,y1000 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { y1000 }),nm->mkNode(Kind::STRING_LENGTH, { x999 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_EMP, { x1001, y1002 }, nm->mkNode(Kind::STRING_CONTAINS, { x1001,y1002 }), e1117, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { y1002 }),e1119 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONTAINS_IS_EMP, { x1003, y1004 }, nm->mkNode(Kind::STRING_CONTAINS, { x1003,y1004 }), nm->mkNode(Kind::EQUAL, { x1003,y1004 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { x1003 }),e1119 }), Node::null());
db.addRule(ProofRewriteRule::STR_CONCAT_EMP, { xs1005, ys1006 }, nm->mkNode(Kind::STRING_CONCAT, { xs1005,e1127,ys1006 }), nm->mkNode(Kind::STRING_CONCAT, { xs1005,ys1006 }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_AT_ELIM, { x1007, n1008 }, nm->mkNode(Kind::STRING_CHARAT, { x1007,n1008 }), nm->mkNode(Kind::STRING_SUBSTR, { x1007,n1008,e1121 }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_SELF, { t1009, s1010 }, nm->mkNode(Kind::STRING_REPLACE, { t1009,t1009,s1010 }), s1010, e1117, Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_NO_CONTAINS, { t1011, s1012, r1013 }, nm->mkNode(Kind::STRING_REPLACE, { t1011,s1012,r1013 }), t1011, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { t1011,s1012 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_REPLACE_EMPTY, { t1014, s1015 }, nm->mkNode(Kind::STRING_REPLACE, { t1014,e1127,s1015 }), nm->mkNode(Kind::STRING_CONCAT, { s1015,t1014 }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_LEN_CONCAT_REC, { s11016, s21017, s31018 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s11016,s21017,s31018 }) }), nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s21017,s31018 }) }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1105 }),nm->mkNode(Kind::ADD, { nm->mkNode(Kind::STRING_LENGTH, { s11016 }),t1105 }) }));
db.addRule(ProofRewriteRule::STR_INDEXOF_SELF, { t1019, n1020 }, nm->mkNode(Kind::STRING_INDEXOF, { t1019,t1019,n1020 }), nm->mkNode(Kind::STRING_INDEXOF, { e1127,e1127,n1020 }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_INDEXOF_NO_CONTAINS, { t1021, s1022, n1023 }, nm->mkNode(Kind::STRING_INDEXOF, { t1021,s1022,n1023 }), nm->mkConstRealOrInt(-(Rational(1))), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_SUBSTR, { t1021,n1023,nm->mkNode(Kind::STRING_LENGTH, { t1021 }) }),s1022 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_TO_LOWER_CONCAT, { s11024, s21025, s31026 }, nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_CONCAT, { s11024,s21025,s31026 }) }), nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_CONCAT, { s21025,s31026 }) }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1106 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_TO_LOWER, { s11024 }),t1106 }) }));
db.addRule(ProofRewriteRule::STR_TO_UPPER_CONCAT, { s11027, s21028, s31029 }, nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_CONCAT, { s11027,s21028,s31029 }) }), nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_CONCAT, { s21028,s31029 }) }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1107 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_TO_UPPER, { s11027 }),t1107 }) }));
db.addRule(ProofRewriteRule::STR_TO_LOWER_UPPER, { s1030 }, nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_TO_UPPER, { s1030 }) }), nm->mkNode(Kind::STRING_TO_LOWER, { s1030 }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_TO_UPPER_LOWER, { s1031 }, nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_TO_LOWER, { s1031 }) }), nm->mkNode(Kind::STRING_TO_UPPER, { s1031 }), e1117, Node::null());
db.addRule(ProofRewriteRule::RE_ALL_ELIM, {  }, nm->mkNode(Kind::REGEXP_ALL, {  }), e1124, e1117, Node::null());
db.addRule(ProofRewriteRule::RE_OPT_ELIM, { x1032 }, nm->mkNode(Kind::REGEXP_OPT, { x1032 }), nm->mkNode(Kind::REGEXP_UNION, { e1126,x1032 }), e1117, Node::null());
db.addRule(ProofRewriteRule::RE_DIFF_ELIM, { x1033, y1034 }, nm->mkNode(Kind::REGEXP_DIFF, { x1033,y1034 }), nm->mkNode(Kind::REGEXP_INTER, { x1033,nm->mkNode(Kind::REGEXP_COMPLEMENT, { y1034 }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_EMP, { xs1035, ys1036 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1035,e1126,ys1036 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1035,ys1036 }), e1117, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_NONE, { xs1037, ys1038 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1037,e1123,ys1038 }), e1123, e1117, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_FLATTEN, { xs1039, s1040, ys1041, zs1042 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1039,nm->mkNode(Kind::REGEXP_CONCAT, { s1040,ys1041 }),zs1042 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1039,s1040,ys1041,zs1042 }), e1117, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_STAR_SWAP, { xs1043, r1044, ys1045 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1043,e1125,r1044,ys1045 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1043,r1044,e1125,ys1045 }), e1117, Node::null());
db.addRule(ProofRewriteRule::RE_CONCAT_MERGE, { xs1046, s1047, t1048, ys1049 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1046,nm->mkNode(Kind::STRING_TO_REGEXP, { s1047 }),nm->mkNode(Kind::STRING_TO_REGEXP, { t1048 }),ys1049 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1046,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1047,t1048 }) }),ys1049 }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1108 }),t1108 }));
db.addRule(ProofRewriteRule::RE_UNION_ALL, { xs1050, ys1051 }, nm->mkNode(Kind::REGEXP_UNION, { xs1050,e1124,ys1051 }), e1124, e1117, Node::null());
db.addRule(ProofRewriteRule::RE_UNION_NONE, { xs1052, ys1053 }, nm->mkNode(Kind::REGEXP_UNION, { xs1052,e1123,ys1053 }), nm->mkNode(Kind::REGEXP_UNION, { xs1052,ys1053 }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1109 }),t1109 }));
db.addRule(ProofRewriteRule::RE_UNION_FLATTEN, { xs1054, b1055, ys1056, zs1057 }, nm->mkNode(Kind::REGEXP_UNION, { xs1054,nm->mkNode(Kind::REGEXP_UNION, { b1055,ys1056 }),zs1057 }), nm->mkNode(Kind::REGEXP_UNION, { xs1054,b1055,ys1056,zs1057 }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1110 }),t1110 }));
db.addRule(ProofRewriteRule::RE_UNION_DUP, { xs1058, b1059, ys1060, zs1061 }, nm->mkNode(Kind::REGEXP_UNION, { xs1058,b1059,ys1060,b1059,zs1061 }), nm->mkNode(Kind::REGEXP_UNION, { xs1058,b1059,ys1060,zs1061 }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1111 }),t1111 }));
db.addRule(ProofRewriteRule::RE_INTER_ALL, { xs1062, ys1063 }, nm->mkNode(Kind::REGEXP_INTER, { xs1062,e1124,ys1063 }), nm->mkNode(Kind::REGEXP_INTER, { xs1062,ys1063 }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1112 }),t1112 }));
db.addRule(ProofRewriteRule::RE_INTER_NONE, { xs1064, ys1065 }, nm->mkNode(Kind::REGEXP_INTER, { xs1064,e1123,ys1065 }), e1123, e1117, Node::null());
db.addRule(ProofRewriteRule::RE_INTER_FLATTEN, { xs1066, b1067, ys1068, zs1069 }, nm->mkNode(Kind::REGEXP_INTER, { xs1066,nm->mkNode(Kind::REGEXP_INTER, { b1067,ys1068 }),zs1069 }), nm->mkNode(Kind::REGEXP_INTER, { xs1066,b1067,ys1068,zs1069 }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1113 }),t1113 }));
db.addRule(ProofRewriteRule::RE_INTER_DUP, { xs1070, b1071, ys1072, zs1073 }, nm->mkNode(Kind::REGEXP_INTER, { xs1070,b1071,ys1072,b1071,zs1073 }), nm->mkNode(Kind::REGEXP_INTER, { xs1070,b1071,ys1072,zs1073 }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1114 }),t1114 }));
db.addRule(ProofRewriteRule::RE_LOOP_NEG, { n1074, m1075, r1076 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::REGEXP_LOOP)),n1074,m1075,r1076 }), e1123, nm->mkNode(Kind::GT, { n1074,m1075 }), Node::null());
db.addRule(ProofRewriteRule::RE_INTER_CSTRING, { xs1077, ys1078, s1079 }, nm->mkNode(Kind::REGEXP_INTER, { xs1077,e1122,ys1078 }), e1122, nm->mkNode(Kind::STRING_IN_REGEXP, { s1079,nm->mkNode(Kind::REGEXP_INTER, { xs1077,ys1078 }) }), Node::null());
db.addRule(ProofRewriteRule::RE_INTER_CSTRING_NEG, { xs1080, ys1081, s1082 }, nm->mkNode(Kind::REGEXP_INTER, { xs1080,nm->mkNode(Kind::STRING_TO_REGEXP, { s1082 }),ys1081 }), e1123, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1082,nm->mkNode(Kind::REGEXP_INTER, { xs1080,ys1081 }) }) }), Node::null());
db.addRule(ProofRewriteRule::STR_NTH_ELIM_CODE, { s1083, n1084 }, nm->mkNode(Kind::SEQ_NTH, { s1083,n1084 }), nm->mkNode(Kind::STRING_TO_CODE, { nm->mkNode(Kind::STRING_SUBSTR, { s1083,n1084,e1121 }) }), e1117, Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_INCLUDE, { s11085, s21086, n1087 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11085,s21086 }),e1119,n1087 }), s11085, nm->mkNode(Kind::EQUAL, { n1087,nm->mkNode(Kind::STRING_LENGTH, { s11085 }) }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_INCLUDE_PRE, { s11088, s21089, s31090, n1091 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11088,s21089,s31090 }),e1119,n1091 }), nm->mkNode(Kind::STRING_CONCAT, { s11088,nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s21089,s31090 }),e1119,nm->mkNode(Kind::SUB, { n1091,e1120 }) }) }), nm->mkNode(Kind::GEQ, { n1091,e1120 }), Node::null());
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_SKIP, { s11092, s21093, s31094, n1095, m1096 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11092,s21093,s31094 }),n1095,m1096 }), nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s21093,s31094 }),nm->mkNode(Kind::SUB, { n1095,e1118 }),m1096 }), nm->mkNode(Kind::GEQ, { n1095,e1118 }), Node::null());
db.addRule(ProofRewriteRule::SEQ_REV_CONCAT, { x1097, y1098, z1099 }, nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_CONCAT, { x1097,y1098,z1099 }) }), nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_CONCAT, { x1097,y1098 }) }), e1117, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1115 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_REV, { z1099 }),t1115 }) }));
db.addRule(ProofRewriteRule::SEQ_LEN_UNIT, { x1100 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::SEQ_UNIT, { x1100 }) }), e1121, e1117, Node::null());
db.addRule(ProofRewriteRule::SEQ_NTH_UNIT, { x1101 }, nm->mkNode(Kind::SEQ_NTH, { nm->mkNode(Kind::SEQ_UNIT, { x1101 }),e1119 }), x1101, e1117, Node::null());
db.addRule(ProofRewriteRule::SEQ_REV_UNIT, { x1102 }, nm->mkNode(Kind::STRING_REV, { e1116 }), e1116, e1117, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
