/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Haniel Barbosa
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2024 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_uf_rewrites(RewriteDb& db)
{
  NodeManager* nm = NodeManager::currentNM();

  // Variables
  Node t1331 = nm->mkBoundVar("t1331", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1332 = nm->mkBoundVar("t1332", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1333 = nm->mkBoundVar("s1333", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1334 = nm->mkBoundVar("t1334", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1335 = nm->mkBoundVar("s1335", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1336 = nm->mkBoundVar("x1336", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n1337 = nm->mkBoundVar("n1337", nm->integerType());

  // Definitions
Node e1338 = nm->mkNode(Kind::BITVECTOR_SIZE, { x1336 });
Node e1339 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-uf-rewrites.cpp
            db.addRule(ProofRewriteRule::EQ_REFL, { t1331 }, nm->mkNode(Kind::EQUAL, { t1331,t1331 }), e1339, e1339, Node::null());
db.addRule(ProofRewriteRule::EQ_SYMM, { t1332, s1333 }, nm->mkNode(Kind::EQUAL, { t1332,s1333 }), nm->mkNode(Kind::EQUAL, { s1333,t1332 }), e1339, Node::null());
db.addRule(ProofRewriteRule::DISTINCT_BINARY_ELIM, { t1334, s1335 }, nm->mkNode(Kind::DISTINCT, { t1334,s1335 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t1334,s1335 }) }), e1339, Node::null());
db.addRule(ProofRewriteRule::UF_BV2NAT_GEQ_ELIM, { x1336, n1337 }, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::BITVECTOR_TO_NAT, { x1336 }),n1337 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { n1337,e1338 }),nm->mkConst(false),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { n1337,nm->mkConstRealOrInt(Rational(0)) }),e1339,nm->mkNode(Kind::BITVECTOR_UGE, { x1336,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),e1338,n1337 }) }) }) }), e1339, Node::null());
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
